#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$check=$furl;
$check=~s/http:\/\///;
($check,@garb)=split("/",$check);
&errauth unless ($ENV{HTTP_REFERER}=~/$check/);
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$pdate="$month $date $year";
if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
open (F, "<$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
@pass=<F>;
flock(F,$LOCK_UN);
close (F);
chop($admpass=shift(@pass));
if ($admpass ne $encline)
{
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
}
if ($data{method} eq "maillist")
{
	open (F,"<$basepath/maillist");
	flock(F,$LOCK_EX);
	@emails=<F>;
	flock(F,$LOCK_UN);
	close (F);
	open(F,"<$adcpath/mail/list.hdr");
	flock(F,$LOCK_EX);
	@header=<F>;
	flock(F,$LOCK_UN);
	close(F);
	open(F,"<$adcpath/mail/list.btm");
	flock(F,$LOCK_EX);
	@bottom=<F>;
	flock(F,$LOCK_UN);
	close(F);
	$count=0;
	if (@emails>0)
	{
	foreach(@emails)
	{
	chop;
	$count++;
	open (MAIL,"|$progmail");
	print MAIL "To: $_\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: $data{subject}\n\n";
	print MAIL @header;
	print MAIL "$data{body}\n\n";
	print MAIL @bottom;
	close (MAIL);
	}
	}
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">MAILLIST STATUS</font>
	<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
	<tr><td><font size=2>Newsletter was sent to $count users</font></td></tr>
	</table>
	</td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "admin")
{
	open (F,"+<$basepath/adcenter.pwd");
	flock(F,$LOCK_EX);
	@pass=<F>;
	$pass[0]=crypt($data{name},$data{name}).":".crypt($data{password},$data{password})."\n";
	truncate (F,0);
	seek (F,0,0);
	print F @pass;
	flock(F,$LOCK_UN);
	close (F);
	open(F,"<$basepath/disabled");
	flock(F,$LOCK_EX);
	@listing=<F>;
	flock(F,$LOCK_UN);
	close(F);
	foreach(@listing)
	{
		chop;
		$_="<option>$_</option>\n";
	}
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">CHANGE ADMIN LOGIN/PASSWORD</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="admin">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Login</b></font></td>
	<td width="65%"><input type="text" name="name" size="48" maxlength=8 value="$data{name}"></td></tr>
	<tr><td width="35%"><font size="2"><b>Password</b></font></td>
	<td width="65%"><input type="text" name="password" maxlength=8 size="48" value="$data{password}"></td></tr>
	<tr><td colspan=2 align="right"><input type="submit" value="Change login and password"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">REMOVE USER</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remove">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Username</b></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Remove User"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">CHANGE IMPRESSION RATIO</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ratio">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Ratio</b> <input type="text" name="ratio" size=4></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Change banner ratio"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">GIVE IMPRESSION CREDITS</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="impcred">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="impcred" size=4> <b>to</b></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Give impression credits"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">GIVE CLICK CREDITS</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="clccred">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="clccred" size=4> <b>to</b></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Give click credits"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET BLITZ TO USER</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="blitz">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="cred" size=4> <b>to</b></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Set blitz"></td></tr>
	</table></form></td></tr>
	~;
	if ($weighttype)
	{
	$result.=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET "WEIGHT" FOR USER</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="wght">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><font size="2"><select name="wght"><option>1<option>2<option>3<option>4<option>5<option>6<option>7<option>8<option>9<option>10</select> <b>for</b></font></td>
	<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Set weight"></td></tr>
	</table></form></td></tr>
	~;
	}
	$result.=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">CHANGE USER'S URL</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="changeurl">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td width="35%"><input type="text" name="uuser" size=15 value="Username"></td>
	<td width="65%" align="right"><input type="text" value="User's URL" name="uurl" size="45" maxlength="150"></td></tr>
	<tr><td width="35%"></td>
	<td width="65%" align="right"><input type="submit" value="Change user's URL"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">GET USERLIST</font>
	<form method="post" action="$cgi/adcglst.pl" target="_blank">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td align="right"><input type="submit" value="Get userlist"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">GET USERINFO</font>
	<form method="post" action="$cgi/adcgnfo.pl" target="_blank">
	<input type="hidden" name="method" value="userinfo">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td align="right"><input type="text" name="name" size=47 value="username"><input type="submit" value="Get userinfo"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">DISABLE ACCOUNT</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="disable">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td align="right"><input type=text name="username" size=47 value="username"><input type="submit" value="Disable account"></td></tr>
	</table></form></td></tr>
	<tr><td width="450">
	<font size=5 color="#00B0B0">ENABLE ACCOUNT</font>
	<form method="post" action="$cgi/adcadmin.pl">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="enable">
	<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
	<tr><td align="right"><select name="username">@listing</select><input type="submit" value="Enable account"></td></tr>
	</table></form></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "remove")
{
	open (F,"+<$basepath/adcenter.pwd");
	flock(F,$LOCK_EX);
	@pass=<F>;
	$encname=crypt($data{username},$data{username});
	foreach(@pass)
	{
		if ($_=~/^$encname/)
		{
			$flag=1;
			next;
		}
		push (@npass,$_);
	}
	truncate (F,0);
	seek (F,0,0);
	print F @npass;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	@users=<F>;
	foreach(@users)
	{
		next if ($_=~/^$data{username}\t/);
		push (@nusers,$_);
	}
	truncate (F,0);
	seek (F,0,0);
	print F @nusers;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"+<$basepath/global");
	flock(F,$LOCK_EX);
	@users=<F>;
	foreach(@users)
	{
		next if ($_=~/^$data{username}\t/);
		push (@nuusers,$_);
	}
	truncate (F,0);
	seek (F,0,0);
	print F @nuusers;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"+<$basepath/adcenter.srh");
	flock(F,$LOCK_EX);
	@users=<F>;
	foreach(@users)
	{
		next if ($_=~/^$data{username}\t/);
		push (@neusers,$_);
	}
	truncate (F,0);
	seek (F,0,0);
	print F @neusers;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"+<$basepath/adcenter.bup");
	flock(F,$LOCK_EX);
	@users=<F>;
	foreach(@users)
	{
		($eml,$usrnm)=split("\t",$_);
		next if ($usrnm eq $data{username});
		push (@newusers,$_);
	}
	truncate (F,0);
	seek (F,0,0);
	print F @newusers;
	flock(F,$LOCK_UN);
	close (F);
	unlink ("$basepath/$data{username}/impressions");
	unlink ("$basepath/$data{username}/impressionsb");
	unlink ("$basepath/$data{username}/impressionsr");
	unlink ("$basepath/$data{username}/maillist");
	unlink ("$basepath/$data{username}/visitors");
	unlink ("$basepath/$data{username}/lastact");
	unlink ("$basepath/$data{username}/clicks");
	unlink ("$basepath/$data{username}/clicksb");
	unlink ("$basepath/$data{username}/clicksr");
	unlink ("$basepath/$data{username}/credits");
	unlink ("$basepath/$data{username}/affilc");
	unlink ("$basepath/$data{username}/affilx");
	unlink ("$basepath/$data{username}/affiliate");
	unlink ("$basepath/$data{username}/reset");
	unlink ("$basepath/$data{username}/dflag");
	unlink ("$basepath/$data{username}/join");
	unlink ("$basepath/$data{username}/banner");
	unlink ("$basepath/$data{username}/target");
	unlink ("$basepath/$data{username}/timeman");
	unlink ("$basepath/$data{username}/counter");
	unlink ("$basepath/$data{username}/lastimp");
	unlink ("$basepath/$data{username}/lastclc");
	rmdir ("$basepath/$data{username}");
	unlink ("$adcpath/banners/$data{username}.gif");
	if ($flag)
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">REMOVE STATUS</font><br><br><font size=2>User <b>$data{username}</b> was removed successfully</font></td></tr>
		~;
	}
	else
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">REMOVE STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
		~;
	}
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "ratio")
{
	open (F,"+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	@db=<F>;
	foreach (@db)
	{
		if ($_=~/^$data{username}\t/)
		{
			($user,$userurl,$group,$oratio,$ref,$wei)=split("\t",$_);
			$_="$user\t$userurl\t$group\t$data{ratio}\t$ref\t$wei";
			$flag=1;
			last;
		}
	}
	truncate (F,0);
	seek (F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close (F);
	if ($flag)
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">CHANGE RATIO STATUS</font><br><br><font size=2>Ratio for <b>$data{username}</b> was changed to $data{ratio} successfully</font></td></tr>
		~;
	}
	else
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">CHANGE RATIO STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
		~;
	}
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "impcred")
{
	($day,$month,$date,$time,$year)=split(" ",scalar localtime);
	open (F,"+<$basepath/$data{username}/credits");
	flock(F,$LOCK_EX);
	@db=<F>;
	($imp,$clc)=split("\t",$db[0]);
	$imp=$imp+$data{impcred};
	truncate (F,0);
	seek (F,0,0);
	print F "$imp\t$clc";
	flock(F,$LOCK_UN);
	close (F);
	open (F,">$basepath/$data{username}/lastimp");
	flock(F,$LOCK_EX);
	print F "$data{impcred}\n$month $date $year\n";
	flock(F,$LOCK_UN);
	close (F);
	if (-e "$basepath/$data{username}/credits")
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ADD IMPRESSION CREDITS STATUS</font><br><br><font size=2>$data{impcred} credits were added succesfully to <b>$data{username}</b></font></td></tr>
	~;
	}
	else
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ADD IMPRESSION CREDITS STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
	~;
	}
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "clccred")
{
	($day,$month,$date,$time,$year)=split(" ",scalar localtime);
	open (F,"+<$basepath/$data{username}/credits");
	flock(F,$LOCK_EX);
	@db=<F>;
	($imp,$clc)=split("\t",$db[0]);
	$clc=$clc+$data{clccred};
	truncate (F,0);
	seek (F,0,0);
	print F "$imp\t$clc";
	flock(F,$LOCK_UN);
	close (F);
	open (F,">$basepath/$data{username}/lastclc");
	flock(F,$LOCK_EX);
	print F "$data{clccred}\n$month $date $year\n";
	flock(F,$LOCK_UN);
	close (F);
	if (-e "$basepath/$data{username}/credits")
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ADD CLICK CREDITS STATUS</font><br><br><font size=2>$data{clccred} credits were added succesfully to <b>$data{username}</b></font></td></tr>
	~;
	}
	else
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ADD CLICK CREDITS STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
	~;
	}
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "blitz")
{
	unless (-e "$basepath/$data{username}/credits")
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET BLITZ STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
	}
	open (F,">>$basepath/blitz");
	flock(F,$LOCK_EX);
	print F "$data{username}\t$data{cred}\n";
	flock(F,$LOCK_UN);
	close (F);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET BLITZ STATUS</font><br><br><font size=2>Blitz with $data{cred} credits was set to <b>$data{username}</b></font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "wght")
{
	unless (-e "$basepath/$data{username}/credits")
	{
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET WEIGHT STATUS</font><br><br><font size=2>User <b>$data{username}</b> was not found in the database</font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
	}
	open (F,"+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	@users=<F>;
	foreach(@users)
	{
		chop;
		($user,$userurl,$usercat,$userrat,$userref,$userw)=split("\t",$_);
		if ($user eq $data{username}){$_="$user\t$userurl\t$usercat\t$userrat\t$userref\t$data{wght}\n";last;}
		$_="$_\n";
	}
	truncate(F,0);
	seek(F,0,0);
	print F @users;
	flock(F,$LOCK_UN);
	close (F);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET WEIGHT STATUS</font><br><br><font size=2>Weight of <b>$data{username}</b> was changed to <b>$data{wght}</b></font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "remove_banner")
{
	open (F,">$basepath/$data{user}/banner");
	flock(F,$LOCK_EX);
	print F "Banner was removed by admin (Policy)";
	flock(F,$LOCK_UN);
	close (F);
	unlink ("$adcpath/queye/$data{user}.gif");
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">BANNER STATUS</font>
	<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
	<tr><td><font size=2>Banner was removed successfully</font></td></tr>
	</table>
	</td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "accept_banner")
{
	open (F,"<$adcpath/queye/$data{user}.gif");
	flock(F,$LOCK_EX);
	binmode F;
	@file=<F>;
	flock(F,$LOCK_UN);
	close(F);
	open (F,">$adcpath/banners/$data{user}.gif");
	flock(F,$LOCK_EX);
	binmode F;
	print F @file;
	flock(F,$LOCK_UN);
	close (F);
	open (FL, ">$basepath/$data{user}/banner");
	flock(FL,$LOCK_EX);
	print FL $pdate;
	flock(FL,$LOCK_UN);
	close(FL);
	unlink ("$adcpath/queye/$data{user}.gif");
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">BANNER STATUS</font>
	<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
	<tr><td><font size=2>Banner was accepted successfully</font></td></tr>
	</table>
	</td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "changeurl")
{
	open (F,"+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	@db=<F>;
	foreach (@db)
	{
		if ($_=~/^$data{uuser}\t/)
		{
			($user,$userurl,$group,$oratio,$ref,$wei)=split("\t",$_);
			$_="$user\t$data{uurl}\t$group\t$oratio\t$ref\t$wei";
			$flag=1;
			last;
		}
	}
	truncate (F,0);
	seek (F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"+<$basepath/adcenter.srh");
	flock(F,$LOCK_EX);
	@db=<F>;
	foreach (@db)
	{
		if ($_=~/^$data{uuser}\t/)
		{
			($user,$userurl,$group,$title,$desc,$keyw)=split("\t",$_);
			$_="$user\t$data{uurl}\t$group\t$title\t$desc\t$keyw";
			last;
		}
	}
	truncate (F,0);
	seek (F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close (F);
	if ($flag)
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">CHANGE USER URL STATUS</font><br><br><font size=2>URL to <b>$data{uuser}</b> site was changed successfully</font></td></tr>
		~;
	}
	else
	{
		$result=qq~
		<tr><td width="450">
		<font size=5 color="#00B0B0">CHANGE USER URL STATUS</font><br><br><font size=2>User <b>$data{uuser}</b> was not found in the database</font></td></tr>
		~;
	}
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "general")
{
open(F,">adc.cfg");
flock(F,$LOCK_EX);
print F qq~#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$adcpath="$data{adcpath}";
\$basepath="$data{basepath}";
\$cgi="$data{cgi}";
\$adcenter="$data{adcenter}";
\$sysid="$data{sysid}";
\$progmail="$data{progmail}";
\$email='$data{email}';
\$furl="$data{furl}";
%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
%calendar=('Jan','31','Feb','28','Mar','31','Apr','30','May','31','Jun','30','Jul','31','Aug','31','Sep','30','Oct','31','Nov','30','Dec','31');
\$yourname="$data{yourname}";
\$defaultratio=$data{defaultratio};
\$refratio=$data{refratio};
\$owntitle="$data{owntitle}";
\$startcred=$data{startcred};
\$clickratio=$data{clickratio};
\$banheight=$data{banheight};
\$banwidth=$data{banwidth};
\$mbanheight=$data{mbanheight};
\$mbanwidth=$data{mbanwidth};
\$mfilesize=$data{mfilesize};
\$weighttype=$data{weighttype};
\$enablecounter=$data{enablecounter};
\$enablemaillist=$data{enablemaillist};
\$license="$license";
\$uselwp=$data{uselwp};
\$inactive_limit=$data{inactive_limit};
\$usetar=$data{usetar};
\$usezlib=$data{usezlib};
\$LOCK_SH=1;
\$LOCK_EX=2;
\$LOCK_NB=4;
\$LOCK_UN=8;
~;
flock(F,$LOCK_UN);
close(F);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">CONFIG STATUS</font><br><br><font size=2>General settings were changed succesfully</font></td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
if ($data{method} eq "disable")
{
	open (F,">$basepath/$data{username}/dflag");
	close (F);
	open (F,">>$basepath/disabled");
	flock(F,$LOCK_EX);
	print F "$data{username}\n";
	flock(F,$LOCK_UN);
	close (F);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ACCOUNT STATUS</font><br><br><font size=2>Account <b>$data{username}</b> was disabled</font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "enable")
{
	unlink ("$basepath/$data{username}/dflag");
	open (F,"+<$basepath/disabled");
	flock(F,$LOCK_EX);
	@disble=<F>;
	foreach(@disble)
	{
		chop;
		next if ($_ eq $data{username});
		push(@ndisble,"$_\n");
	}
	truncate (F,0);
	seek (F,0,0);
	print F @ndisble;
	flock(F,$LOCK_UN);
	close (F);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">ACCOUNT STATUS</font><br><br><font size=2>Account <b>$data{username}</b> was enabled</font></td></tr>
	~;
	open (F,"<$adcpath/template/adm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub errauth
{
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
