#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
($hours)=split(":",$time);
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$time=~s/://g;

($user,$random)=split("&",$ENV{QUERY_STRING});
if (!$user || !(-d "$basepath/$user"))
{
	$username=$yourname;
	if (-e "$adcpath/banners/$username.jpg"){$banner="$adcenter/banners0/$username.jpg";}
	else {$banner="$adcenter/banners/$username.gif";}
	print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
	print "P3P: CP=\"UNI\"\n";
	print "set-cookie: adcenterurl=$username; \n";
	print "Location: $banner\n\n";
	exit;
}
open (F,">$basepath/$user/lastact");
flock(F,$LOCK_EX);
print F $lastact;
flock(F,$LOCK_UN);
close (F);
if (-s "$basepath/blitz")
{
	open(F,"+<$basepath/blitz");
	@blitz=<F>;
	truncate (F,0);
	seek (F,0,0);
	srand;
	$item=$blitz[int(rand scalar(@blitz))];
	chop($item);
	($uname,$ucred)=split("\t",$item);
	if ($uname ne $user)
	{
	$ucred--;
	foreach(@blitz)
	{
		($uuname,$uucred)=split("\t",$_);
		if ($uuname eq $uname)
		{
			next if ($ucred==0);
			$_="$uname\t$ucred\n";
		}
		push(@nblitz,$_);
	}
	print F @nblitz;
	$username=$uname;
	$flag=1;
	$blitzdone=1;
	}
	else {print F @blitz;}
	flock(F,$LOCK_UN);
	close(F);
}
if (!$blitzdone)
{
	open (F, "<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		chop($line);
		($username,$url,$usrgroup,$ratio,$referuser,$weight)=split("\t",$line);
		if ($username eq $user)
		{
			$tgroup=$usrgroup;
			$userratio=$ratio;
			$refus=$referuser;
			$usersurl=$url;
			next;
		}
		$weight=1 if (!$weight || $weight==0);
		$j=0;
		while ($j<$weight)
		{
			push(@data,$line);
			$j++;
		}
	}
	flock(F,$LOCK_UN);
	close (F);
	while ($i<@data)
	{
		srand;
		$item=int(rand (@data));
		($username)=split("\t",$data[$item]);
		open (F,"<$basepath/$username/target");
		flock(F,$LOCK_EX);
		$target=<F>;
		flock(F,$LOCK_UN);
		close(F);
		open (F,"+<$basepath/$username/credits");
		flock(F,$LOCK_EX);
		@credits=<F>;
		($credit,$click)=split("\t",$credits[0]);
		open (FL,"+<$basepath/$username/timeman");
		flock(FL,$LOCK_EX);
		@work=<FL>;
		($onwork,$offwork)=split("\t",$work[$hours]);
		if (($credit>=1 || $click>=1) && -e "$adcpath/banners/$username.gif" && !(-e "$basepath/$username/dflag") && $target=~/$tgroup/ && $onwork<$offwork)
		{
			$credit=$credit-1 if ($credit>=1);
			truncate (F,0);
			seek (F,0,0);
			print F "$credit\t$click";
			flock(F,$LOCK_UN);
			close(F);
			$onwork=$onwork+1;
			foreach $wrk(@work)
			{
				($onw,$ofw)=split("\t",$wrk);
				$wrk="0\t$ofw";
			}
			$work[$hours]="$onwork\t$offwork";
			truncate (FL,0);
			seek (FL,0,0);
			print FL @work;
			flock(FL,$LOCK_UN);
			close(FL);
			$flag=1;
			last;
		}
		flock(F,$LOCK_UN);
		close(F);
		flock(FL,$LOCK_UN);
		close(FL);
		splice(@data,$item,1);
	}
}
$username=$yourname if (!$flag);
open (F,"+<$basepath/$user/credits");
flock(F,$LOCK_EX);
@credits=<F>;
($credit,$click)=split("\t",$credits[0]);
$credit=$credit+$userratio;
truncate (F,0);
seek (F,0,0);
print F "$credit\t$click";
flock(F,$LOCK_UN);
close(F);
if ($refus)
{
	open (F,"+<$basepath/$refus/credits");
	flock(F,$LOCK_EX);
	@credits=<F>;
	($credit,$click)=split("\t",$credits[0]);
	$credit=$credit+$refratio;
	truncate (F,0);
	seek (F,0,0);
	print F "$credit\t$click";
	flock(F,$LOCK_UN);
	close(F);
}

open (STAT,"+<$basepath/$username/impressions");
flock(STAT,$LOCK_EX);
binmode STAT;
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
if (-e "$basepath/$username/affiliate")
{
open (F,"+<$basepath/$username/affiliate");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		$arg3++;
		$_="$arg1\t$arg2\t$arg3\t$arg4";
		$foundflag=1;
		last;
	}
}
push (@lines,"$user\t$usersurl\t1\t0\n") if (!$foundflag);
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F,">$basepath/$username/affiliate");
flock(F,$LOCK_EX);
print F "$user\t$usersurl\t1\t0\n";
flock(F,$LOCK_UN);
close (F);
}
open (F,"+<$basepath/$user/affilx");
flock(F,$LOCK_EX);
$affilx=<F>;
$affilx++;
truncate(F,0);
seek(F,0,0);
print F $affilx;
flock(F,$LOCK_UN);
close (F);

print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "P3P: CP=\"UNI\"\n";
print "set-cookie: adcenterurl=$username; \n";
print "set-cookie: adcentersource=$user; \n";
print "Location: $adcenter/banners/$username.gif\n\n";
 