#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$date,$month,$time,$year)=split(" ",scalar localtime);
($hours)=split(":",$time);
$time=~s/://g;
if (!$cookie{adcenterurl} || !(-d "$basepath/$cookie{adcenterurl}"))
{
	open (F,"<$adcpath/template/nocookie.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}

open (F,"+<$basepath/$cookie{adcenterurl}/credits");
flock(F,$LOCK_EX);
@credits=<F>;
($credit,$click)=split("\t",$credits[0]);
$click=$click-1 if ($click>=1);
truncate (F,0);
seek (F,0,0);
print F "$credit\t$click";
flock(F,$LOCK_UN);
close(F);
open (F,"+<$basepath/$cookie{adcentersource}/credits");
flock(F,$LOCK_EX);
@credits=<F>;
($credit,$click)=split("\t",$credits[0]);
$credit=$credit+$clickratio;
truncate (F,0);
seek (F,0,0);
print F "$credit\t$click";
flock(F,$LOCK_UN);
close(F);
open (STAT,"+<$basepath/$cookie{adcenterurl}/clicks");
flock(STAT,$LOCK_EX);
binmode STAT;
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
open (F,"+<$basepath/$cookie{adcenterurl}/affiliate");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $cookie{adcentersource})
	{
		chop($arg4);
		$arg4++;
		$_="$arg1\t$arg2\t$arg3\t$arg4\n";
		$foundflag=1;
		last;
	}
}
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
open (F,"+<$basepath/$cookie{adcentersource}/affilc");
flock(F,$LOCK_EX);
$affilc=<F>;
$affilc++;
truncate(F,0);
seek(F,0,0);
print F $affilc;
flock(F,$LOCK_UN);
close (F);

open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dt=<F>;
flock(F,$LOCK_UN);
close (F);
foreach (@dt)
{
	($username,$url)=split("\t",$_);
	last if ($username eq $cookie{adcenterurl});
}
$url=$furl if ($cookie{adcenterurl} eq $yourname);
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $url\n\n";
