#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$pdate="$month $date $year";
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
$data{Username}=substr($data{Username},0,8) if (length($data{Username})>8);
if ($data{Username}=~/\W+/ || !$data{Username})
{
	push (@errors,"Illegal script using<br>\n");
	open (F,"<$adcpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
open (F,"<$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
@users=<F>;
flock(F,$LOCK_UN);
close (F);
foreach (@users)
{
	($user,$password)=split(":",$_);
	if (crypt($data{Username},$data{Username}) eq $user)
	{
		push (@errors,"Username $data{Username} is <b>already exist</b>, please choose different<br>\n");
		open (F,"<$adcpath/template/error.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("\n",@htmlpage);
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
        }
}

open (F,">>$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
print F crypt($data{Username},$data{Username}).":".crypt($data{Password},$data{Password})."\n";
flock(F,$LOCK_UN);
close (F);
open (F,">>$basepath/maillist");
flock(F,$LOCK_EX);
print F "$data{EMail}\n";
flock(F,$LOCK_UN);
close (F);
open (F,">>$basepath/global");
flock(F,$LOCK_EX);
print F "$data{Username}\t$data{Name}\t$data{Address}\t$data{City}\t$data{ZipCode}\t$data{Country}\t$data{Phone}\t$data{EMail}\n";
flock(F,$LOCK_UN);
close (F);
mkdir "$basepath/$data{Username}",0777;
chmod 0777,"$basepath/$data{Username}/";
open (F,">$basepath/$data{Username}/counter");
print F "0";
close (F);
open (F,">$basepath/$data{Username}/credits");
print F "$startcred\t0";
close (F);
open (F,">$basepath/$data{Username}/join");
print F "$pdate";
close (F);
open (F,">$basepath/$data{Username}/impressions");
close (F);
open (F,">$basepath/$data{Username}/clicks");
close (F);
open (F,">$basepath/$data{Username}/visitors");
close (F);
open (F,">$basepath/$data{Username}/banner");
print F "not uploaded";
close (F);
open (F,">$basepath/$data{Username}/reset");
print F "$pdate";
close (F);
open (F,">$basepath/$data{Username}/affilx");
print F "0";
close (F);
open (F,">$basepath/$data{Username}/affilc");
print F "0";
close (F);
open (F,">$basepath/$data{Username}/timeman");
print F "0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n0\t1000\n";
close (F);
open (F,">>$basepath/adcenter.db");
flock(F,$LOCK_EX);
print F "$data{Username}\t$data{URL}\t$data{Category}\t$defaultratio\t$cookie{adcenterreferal}\t1\n";
flock(F,$LOCK_UN);
close (F);
open (F,">>$basepath/adcenter.srh");
flock(F,$LOCK_EX);
print F "$data{Username}\t$data{URL}\t$data{Category}\t$data{Sitetitle}\t$data{Description}\t$data{Keywords}\n";
flock(F,$LOCK_UN);
close (F);
open (F,">>$basepath/adcenter.bup");
flock(F,$LOCK_EX);
print F "$data{EMail}\t$data{Username}\t$data{Password}\n";
flock(F,$LOCK_UN);
close (F);
open (F,"<$basepath/category.db");
flock(F,$LOCK_EX);
@categs=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@categs)
{
	chop;
	$categs.="$_##";
}
open (F,">$basepath/$data{Username}/target");
flock(F,$LOCK_EX);
print F $categs;
flock(F,$LOCK_UN);
close(F);
open(F,"<$adcpath/mail/admin.hdr");
@header=<F>;
close(F);
open(F,"<$adcpath/mail/admin.btm");
@bottom=<F>;
close(F);
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $data{EMail} ($data{Name})\n";
print MAIL "Subject: New User Information\n\n";
$ltime=scalar localtime; 
print MAIL @header;
print MAIL "Name: $data{Name}\n";
print MAIL "Address: $data{Address}\n";
print MAIL "City: $data{City}\n";
print MAIL "Zip code: $data{ZipCode}\n";
print MAIL "Country: $data{Country}\n";
print MAIL "Phone number: $data{Phone}\n";
print MAIL "E-mail: $data{EMail}\n";
print MAIL "URL: $data{URL}\n";
print MAIL "Category: $data{Category}\n";
print MAIL "-" x 75 . "\n";
print MAIL "Username: $data{Username}\n";
print MAIL "Password: $data{Password}\n";
print MAIL @bottom;
close (MAIL);
open(F,"<$adcpath/mail/user.hdr");
@header=<F>;
close(F);
open(F,"<$adcpath/mail/user.btm");
@bottom=<F>;
close(F);
open (MAIL,"|$progmail");
print MAIL "To: $data{EMail}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Welcome to our banner network\n\n";
$ltime=scalar localtime; 
print MAIL @header;
print MAIL "You must insert following code to your html page:\n\n";
print MAIL "<!--Begin $owntitle code-->\n";
print MAIL "<center><a href=\"$cgi/adcredir.pl\" target=\"_top\">\n";
print MAIL "<script>\n";
print MAIL "document.write('<img src=\"$cgi/adcnet.pl?$data{Username}&'+Math.random()+'\" border=\"0\" width=\"$banwidth\" height=\"$banheight\"></a><br><a href=\"$cgi/adcclick.pl?$data{Username}\" target=\"_top\"><img src=\"$adcenter/images/network.gif\" border=\"0\" width=\"$mbanwidth\" height=\"$mbanheight\"></a>');\n";
print MAIL "</script>\n";
print MAIL "</center>\n";
print MAIL "<!--End $owntitle code-->\n\n";
if ($enablecounter)
{
print MAIL "If you haven't counter on your page - you can use our free counter! Easy include following code to your html page:\n\n";
print MAIL "<!--Begin $owntitle counter code-->\n";
print MAIL qq~<script type="text/javascript" language="Javascript">\n~;
print MAIL qq~document.write('<script src="$cgi/nph-adccount.pl?$data{Username}"><\\/script>');\n~;
print MAIL qq~</script>\n~;
print MAIL "<!--End $owntitle counter code-->\n\n";
}
if ($enablemaillist)
{
print MAIL "Please insert following code to your page so your visitors can subscribe/unsubscribe to your mailling list:\n\n";
print MAIL "<!--Begin $owntitle maillist code-->\n";
print MAIL "<form action=\"$cgi/adcsubsc.pl\" method=\"post\"><input type=\"hidden\" name=\"destination\" value=\"$data{Username}\">Your email: <input type=\"text\" size=\"30\" name=\"email\"><input type=\"submit\" value=\"Subscribe me\"><br><font size=1><input type=\"radio\" name=\"method\" checked value=\"subscribe\"> Subscribe\&nbsp;\&nbsp;\&nbsp;<input type=\"radio\" name=\"method\" value=\"unsubscribe\"> Unsubscribe</font></form>\n";
print MAIL "<!--End $owntitle maillist code-->\n\n";
}
print MAIL "-" x 75 . "\n";
print MAIL "Username: $data{Username}\n";
print MAIL "Password: $data{Password}\n\n";
print MAIL @bottom;
close (MAIL);

$result=qq~
Congratulations! You became registered user in our free banner network.
Now you can upload your banner to our server in Member's Section. Also there you can track your statistics and change some options.
<p>You must insert following code to your html page:<br><b><font size="2">
<center><textarea cols=50 rows=5>
&lt;!--Begin $owntitle code--&gt;<br>
&lt;center&gt;&lt;a href=\"$cgi/adcredir.pl\" target=\"_top\"&gt;
&lt;script&gt;
document.write('&lt;img src=\"$cgi/adcnet.pl?$data{Username}&'+Math.random()+'\" border=\"0\" width=\"$banwidth\" height=\"$banheight\"&gt;&lt;/a&gt;&lt;br&gt;&lt;a href=\"$cgi/adcclick.pl?$data{Username}\" target=\"_top\"&gt;&lt;img src=\"$adcenter/images/network.gif\" border=\"0\" width=\"$mbanwidth\" height=\"$mbanheight\"&gt;&lt;/a&gt;');
&lt;/script&gt;
&lt;/center&gt;
&lt;!--End $owntitle code--&gt;
</textarea></center></font></b></p>
~;
if ($enablecounter)
{
$result.=qq~
<p>If you haven't counter on your page - you can use our free counter! Easy place 
following code to your html page:<br><b><font size="2">
<center><textarea cols=50 rows=5>
&lt;!--Begin $owntitle counter code--&gt;
<script type="text/javascript" language="Javascript">
document.write('<script src="$cgi/nph-adccount.pl?$data{Username}"><\\/script>');
</script>
&lt;!--End $owntitle counter code--&gt;
</textarea></center></font></b></p>
~;
}
if ($enablemaillist)
{
$result.=qq~
<p>Please insert following code to your page so your visitors can subscribe to your mailling list:<br><b><font size="2">
<center><textarea cols=50 rows=5>
&lt;!--Begin $owntitle maillist code--&gt;
&lt;form action=\"$cgi/adcsubsc.pl\" method=\"post\"&gt;&lt;input type=\"hidden\" name=\"destination\" value=\"$data{Username}\"&gt;Your email: &lt;input type=\"text\" size=\"30\" name=\"email\"&gt;&lt;input type=\"submit\" value=\"Subscribe me\"&gt;&lt;br&gt;&lt;font size=1&gt;&lt;input type="radio" name="method" checked value="subscribe"&gt; Subscribe &amp;nbsp;&amp;nbsp;&amp;nbsp;&lt;input type="radio" name="method" value="unsubscribe"&gt; Unsubscribe&lt;/font&gt;&lt;/form&gt;
&lt;!--End $owntitle maillist code--&gt;
</textarea></center></font></b></p>
~;
}
open (F,"<$adcpath/template/success.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;

sub error
{
@errors=@_;
open (F,"<$adcpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
