#!/usr/bin/perl
use Socket;

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($field eq "target")
		{
		if ($data{$field}){$data{$field}="$data{$field}##$value";}
		else {$data{$field}=$value;}
		}
		else
		{
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
		}
	}
}
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
$destination=$data{method};

open (F, "<$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
@pass=<F>;
flock(F,$LOCK_UN);
close (F);
chop($admpass=shift(@pass));
&$destination if ($admpass eq $encline);
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;

sub logout
{
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $adcenter\n\n";
}
sub genset
{
$inactive_limit=7 if ($inactive_limit eq "");
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">GENERAL SETTINGS</font>
<form action="$cgi/adcadmin.pl" method="post">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="general">
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td width="40%"><font size=1><b>Exchange title</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="owntitle" value="$owntitle"></font></td></tr>
<tr><td width="40%"><font size=1><b>SystemID</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="sysid" value="$sysid"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to ADCenter directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="adcpath" value="$adcpath"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to databases directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="basepath" value="$basepath"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to ADCenter directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="adcenter" value="$adcenter"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to CGI-BIN directory</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="cgi" value="$cgi"></font></td></tr>
<tr><td width="40%"><font size=1><b>Path to sendmail</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="progmail" value="$progmail"></font></td></tr>
<tr><td width="40%"><font size=1><b>Admin e-mail</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="email" value="$email"></font></td></tr>
<tr><td width="40%"><font size=1><b>URL to your site</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="furl" value="$furl"></font></td></tr>
<tr><td width="40%"><font size=1><b>Default internal account</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="yourname" value="$yourname"></font></td></tr>
<tr><td width="40%"><font size=1><b>Default impressions/impressions ratio</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="defaultratio" value="$defaultratio"></font></td></tr>
<tr><td width="40%"><font size=1><b>Default impressions/clicks ratio</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="clickratio" value="$clickratio"></font></td></tr>
<tr><td width="40%"><font size=1><b>Default referal ratio</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="refratio" value="$refratio"></font></td></tr>
<tr><td width="40%"><font size=1><b>Starting bonus credits</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="startcred" value="$startcred"></font></td></tr>
<tr><td width="40%"><font size=1><b>Banner width</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="banwidth" value="$banwidth"></font></td></tr>
<tr><td width="40%"><font size=1><b>Banner height</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="banheight" value="$banheight"></font></td></tr>
<tr><td width="40%"><font size=1><b>Minibanner width</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mbanwidth" value="$mbanwidth"></font></td></tr>
<tr><td width="40%"><font size=1><b>Minibanner height</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mbanheight" value="$mbanheight"></font></td></tr>
<tr><td width="40%"><font size=1><b>Max banner weight (bytes)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="mfilesize" value="$mfilesize"></font></td></tr>
<tr><td width="40%"><font size=1><b>User weight</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="weighttype" value="$weighttype"></font></td></tr>
<tr><td width="40%"><font size=1><b>Counter feature</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="enablecounter" value="$enablecounter"></font></td></tr>
<tr><td width="40%"><font size=1><b>Maillist feature</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="enablemaillist" value="$enablemaillist"></font></td></tr>
<tr><td width="40%"><font size=1><b>Use LWP module</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="uselwp" value="$uselwp"></font></td></tr>
<tr><td width="40%"><font size=1><b>Inactive limit (days)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="inactive_limit" value="$inactive_limit"></font></td></tr>
<tr><td width="40%"><font size=1><b>Use Archive::Tar module - used for backup (1 - yes, 0 - no)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="usetar" value="$usetar"></font></td></tr>
<tr><td width="40%"><font size=1><b>Use Compress::Zlib module - used for backup (1 - yes, 0 - no)</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="usezlib" value="$usezlib"></font></td></tr>
<tr><td colspan=2 align="right"><font size=2>Your license number is $license. Use it when contact tech support: <a href="mailto:perlbox\@td-systems.com">perlbox\@td-systems.com</a></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Change general settings"></td></tr>
</table></form>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub userman
{
open(F,"<$basepath/disabled");
flock(F,$LOCK_EX);
@listing=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@listing)
{
	chop;
	$_="<option>$_</option>\n";
}
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">CHANGE ADMIN LOGIN/PASSWORD</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="admin">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Login</b></font></td>
<td width="65%"><input type="text" name="name" size="48" maxlength=8 value="$data{name}"></td></tr>
<tr><td width="35%"><font size="2"><b>Password</b></font></td>
<td width="65%"><input type="text" name="password" maxlength=8 size="48" value="$data{password}"></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Change login and password"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">REMOVE USER</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remove">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Username</b></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Remove User"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">CHANGE IMPRESSION RATIO</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="ratio">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Ratio</b> <input type="text" name="ratio" size=4></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Change banner ratio"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">GIVE IMPRESSION CREDITS</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="impcred">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="impcred" size=4> <b>to</b></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Give impression credits"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">GIVE CLICK CREDITS</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="clccred">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="clccred" size=4> <b>to</b></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Give click credits"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">SET BLITZ TO USER</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="blitz">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Add</b> <input type="text" name="cred" size=4> <b>to</b></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Set blitz"></td></tr>
</table></form></td></tr>
~;
if ($weighttype)
{
$result.=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">SET "WEIGHT" FOR USER</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="wght">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><select name="wght"><option>1<option>2<option>3<option>4<option>5<option>6<option>7<option>8<option>9<option>10</select> <b>for</b></font></td>
<td width="65%" align="right"><input type="text" name="username" size="48" value="Username"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Set weight"></td></tr>
</table></form></td></tr>
~;
}
$result.=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">CHANGE USER'S URL</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="changeurl">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><input type="text" name="uuser" size=15 value="Username"></td>
<td width="65%" align="right"><input type="text" value="User's URL" name="uurl" size="45" maxlength="150"></td></tr>
<tr><td width="35%"></td>
<td width="65%" align="right"><input type="submit" value="Change user's URL"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">GET USERLIST</font>
<form method="post" action="$cgi/adcglst.pl" target="_blank">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td align="right"><input type="submit" value="Get userlist"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">GET USERINFO</font>
<form method="post" action="$cgi/adcgnfo.pl" target="_blank">
<input type="hidden" name="method" value="userinfo">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td align="right"><input type="text" name="name" size=47 value="username"><input type="submit" value="Get userinfo"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">DISABLE ACCOUNT</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="disable">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td align="right"><input type=text name="username" size=47 value="username"><input type="submit" value="Disable account"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">ENABLE ACCOUNT</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="enable">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td align="right"><select name="username">@listing</select><input type="submit" value="Enable account"></td></tr>
</table></form></td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
open (F, "<$basepath/maillist");
flock(F,$LOCK_EX);
@emails=<F>;
flock(F,$LOCK_UN);
close(F);
$total=scalar(@emails);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">MAILING LIST</font>
<form method="post" action="$cgi/adcadmin.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="maillist">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td colspan=2 align=center><font size="2">You have <b>$total</b> subscribers</font></td></tr>
<tr><td width="35%"><font size="2"><b>Subject</b></font></td>
<td width="65%"><input type="text" name="subject" size="38" value="$owntitle Newsletter"></td></tr>
<tr><td colspan=2 align="center"><textarea name="body" cols=50 rows=5></textarea></td></tr>
<tr><td colspan=2 align="center"><input type="submit" value="Send newsletter"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">REMOVE FROM MAILLIST</font>
<form method="post" action="$cgi/adcadm.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="remmail">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0" style="border: 0px none rgb(0,0,0)">
<tr><td width="35%"><font size="2"><b>Email</b></font></td>
<td width="65%"><input type="text" name="email" size="38"></td></tr>
<tr><td colspan=2 align="center"><input type="submit" value="Remove"></td></tr>
</table></form></td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remmail
{
open (F, "+<$basepath/maillist");
flock(F,$LOCK_EX);
@emails=<F>;
foreach(@emails)
{
chop;
next if ($_ eq $data{email});
push(@nemails,"$_\n");
}
truncate (F,0);
seek (F,0,0);
print F @nemails;
flock(F,$LOCK_UN);
close (F);
&maillist;
}
sub globstats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@dta)
{
	($username,$url,$usrgroup,$uratio,$referuser)=split("\t",$_);
	open (STAT,"<$basepath/$username/impressions");
	flock(STAT,$LOCK_EX);
	while($line=<STAT>)
	{
		chop($line);
		($tkey,$tval)=split("\t",$line);
		@temp=split("#",$tval);
		foreach(@temp){$genimp+=$_;}
		if ($tkey eq $ldate){foreach(@temp){$todimp+=$_;}}
	}
	flock(STAT,$LOCK_UN);
	close (STAT);
	open (STAT,"<$basepath/$username/clicks");
	flock(STAT,$LOCK_EX);
	while($line=<STAT>)
	{
		chop($line);
		($tkey,$tval)=split("\t",$line);
		@temp=split("#",$tval);
		foreach(@temp){$genclc+=$_;}
		if ($tkey eq $ldate){foreach(@temp){$todclc+=$_;}}
	}
	flock(STAT,$LOCK_UN);
	close (STAT);
}
$genimp=0 if ($genimp eq "");
$genclc=0 if ($genclc eq "");
$todimp=0 if ($todimp eq "");
$todclc=0 if ($todclc eq "");
$members=scalar(@dta);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">GLOBAL STATS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Total members</b></font></td><td width="60%" align="right"><font size=2><b>$members</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Total impressions</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$genimp</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Total clicks</b></font></td><td width="60%" align="right"><font size=2>$genclc</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Total impressions today</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$todimp</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Total clicks today</b></font></td><td width="60%" align="right"><font size=2>$todclc</font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub affiliate
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
@dta=sort(@dta);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">AFFILIATE STATS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="60%" valign="top"><font size=2><b>USERNAME</b></font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>IMPRESSIONS</font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>CLICKS</font></td></tr>
~;
foreach(@dta)
{
	($username,$url,$usrgroup,$uratio,$referuser)=split("\t",$_);
	open (F,"<$basepath/$username/affilx");
	flock(F,$LOCK_EX);
	$affilx=<F>;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"<$basepath/$username/affilc");
	flock(F,$LOCK_EX);
	$affilc=<F>;
	flock(F,$LOCK_UN);
	close (F);
	$affilx=0 unless ($affilx);
	$affilc=0 unless ($affilc);
	$result.=qq~<tr><td width="60%" bgcolor="#C0C0C0" valign="top"><font size=2><b>$username</b></font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$affilx</font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$affilc</font></td></tr>\n~;
}
$result.=qq~
<tr><td width="100%" valign="top" colspan=3><font size=2><form action="$cgi/adcadm.pl" method=post><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="clearaf"><input type=submit value="Clear stats"></form></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub clearaf
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
@dta=sort(@dta);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">AFFILIATE STATS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="60%" valign="top"><font size=2><b>USERNAME</b></font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>IMPRESSIONS</font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>CLICKS</font></td></tr>
~;
foreach(@dta)
{
	($username,$url,$usrgroup,$uratio,$referuser)=split("\t",$_);
	open (F, ">$basepath/$username/affilx");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
	open (F, ">$basepath/$username/affilc");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
	$affilx=0;
	$affilc=0;
	$result.=qq~<tr><td width="60%" bgcolor="#C0C0C0" valign="top"><font size=2><b>$username</b></font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$affilx</font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$affilc</font></td></tr>\n~;
}
$result.=qq~
<tr><td width="100%" valign="top" colspan=3><font size=2><form action="$cgi/adcadmin.pl" method=post><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="clearaf"><input type=submit value="Clear stats"></form></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub banners
{
$data{start}=0 if (!$data{start});
$start=$data{start};
@data=();
open (F,"<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@dta)
{
	($user,$userurl,$group,$oratio,$ref)=split("\t",$_);
	push (@data,$_) if (-e "$adcpath/queye/$user.gif");
}
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>10)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcadm.pl?method=banners&name=$data{name}&password=$data{password}&start=$pstart\"><img src=\"$adcenter/images/prev.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount BANNERS IN EXCHANGE</b></font></td>");
	if ($start*10+10<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcadm.pl?method=banners&name=$data{name}&password=$data{password}&start=$nstart\"><img src=\"$adcenter/images/next.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount BANNERS IN EXCHANGE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*10+10>scalar(@data))
{
	$i=$start*10;
	while($i<scalar(@data))
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		push(@result,"<form action=\"$cgi/adcadmin.pl\" method=\"post\"><input type=\"hidden\" name=\"name\" value=\"$data{name}\"><input type=\"hidden\" name=\"password\" value=\"$data{password}\"><input type=\"hidden\" name=\"user\" value=\"$user\"><li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a></li><br><img src=\"$adcenter/queye/$user.gif\"><br><center><input type=\"submit\" name=\"method\" value=\"remove_banner\"><input type=\"submit\" name=\"method\" value=\"accept_banner\"></center></form>\n");
		$i++;
	}
}
else
{
	$i=$start*10;
	$last=$i+10;
	while($i<$last)
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		push(@result,"<form action=\"$cgi/adcadmin.pl\" method=\"post\"><input type=\"hidden\" name=\"name\" value=\"$data{name}\"><input type=\"hidden\" name=\"password\" value=\"$data{password}\"><input type=\"hidden\" name=\"user\" value=\"$user\"><li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a></li><br><img src=\"$adcenter/queye/$user.gif\"><br><center><input type=\"submit\" name=\"method\" value=\"remove_banner\"><input type=\"submit\" name=\"method\" value=\"accept_banner\"></center></form>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>No banners</li>");
}
$result=qq~
<tr><td width="470">
<font size=5 color="#00B0B0">BANNERS OVERVIEW</font><br>
<ul>@result</ul>
</td></tr>
<tr><td width="470">
@footer
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@html=<F>;
close (F);
$html=join("\n",@html);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub inactive
{
$data{start}=0 if (!$data{start});
$start=$data{start};
@data=();
open (F,"<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@dta)
{
	($user,$userurl,$group,$oratio,$ref)=split("\t",$_);
	push (@data,$_) if ((-M "$basepath/$user/lastact">$inactive_limit || (-M "$basepath/$user/join">$inactive_limit && !(-e "$basepath/$user/lastact"))) && !(-e "$basepath/$user/dflag"));
}
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>10)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcadm.pl?method=inactive&name=$data{name}&password=$data{password}&start=$pstart\"><img src=\"$adcenter/images/prev.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount INACTIVE ACCOUNTS</b></font></td>");
	if ($start*10+10<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcadm.pl?method=inactive&name=$data{name}&password=$data{password}&start=$nstart\"><img src=\"$adcenter/images/next.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount INACTIVE ACCOUNTS</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*10+10>scalar(@data))
{
	$i=$start*10;
	while($i<scalar(@data))
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		open (F, "<$basepath/$user/lastact");
		flock(F,$LOCK_EX);
		@lastact=<F>;
		flock(F,$LOCK_UN);
		close (F);
		$lastact=substr($lastact[0],4,2).".".substr($lastact[0],6,2).".".substr($lastact[0],0,4);
		push(@result,"<form action=\"$cgi/adcadmin.pl\" method=\"post\"><input type=\"hidden\" name=\"name\" value=\"$data{name}\"><input type=\"hidden\" name=\"password\" value=\"$data{password}\"><input type=\"hidden\" name=\"username\" value=\"$user\"><li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a></li><br>Last activity: $lastact<br><center><input type=\"submit\" name=\"method\" value=\"remove\"><input type=\"submit\" name=\"method\" value=\"disable\"></center></form>\n");
		$i++;
	}
}
else
{
	$i=$start*10;
	$last=$i+10;
	while($i<$last)
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		open (F, "<$basepath/$user/lastact");
		flock(F,$LOCK_EX);
		@lastact=<F>;
		flock(F,$LOCK_UN);
		close (F);
		$lastact=substr($lastact[0],4,2).".".substr($lastact[0],6,2).".".substr($lastact[0],0,4);
		push(@result,"<form action=\"$cgi/adcadmin.pl\" method=\"post\"><input type=\"hidden\" name=\"name\" value=\"$data{name}\"><input type=\"hidden\" name=\"password\" value=\"$data{password}\"><input type=\"hidden\" name=\"username\" value=\"$user\"><li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a></li><br>Last activity: $lastact<br><center><input type=\"submit\" name=\"method\" value=\"remove\"><input type=\"submit\" name=\"method\" value=\"disable\"></center></form>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>No inactive accounts</li>");
}
$result=qq~
<tr><td width="470">
<font size=5 color="#00B0B0">INACTIVE ACCOUNTS</font><br>
<ul>@result</ul>
</td></tr>
<tr><td width="470">
@footer
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@html=<F>;
close (F);
$html=join("\n",@html);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub tasman
{
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">REMOVE CATEGORY</font><br>
<font size=2><center>
<form action="$cgi/adcadm.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="category">
<table bgcolor="#00B0B0" width="100%">
~;
open(F,"<$basepath/category.db");
flock(F,$LOCK_EX);
@categ=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@categ)
{
	chop;
	/([^:]+):(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($categ{$field}){$categ{$field}="$categ{$field}##$value";}
		else {$categ{$field}=$value;}
	}
}
foreach $key (sort keys %categ)
{
	$result.="<tr><td colspan=2><font size=2><b>$key</b></font></td></tr>";
	@temp=split("##",$categ{$key});
	$i=0;
	while($i<scalar(@temp))
	{
		$result.="<tr><td width=\"10%\"><input type=checkbox name=target value=\"$key:$temp[$i]\"></td><td width=\"40%\"><font size=2>$temp[$i]</font></td>";
		$i++;
		if ($temp[$i] ne "")
		{
		$result.="<td width=\"10%\"><input type=checkbox name=target value=\"$key:$temp[$i]\"></td><td width=\"40%\"><font size=2>$temp[$i]</font></td></tr>\n";
		}
		else {$result.="<td></td><td></td></tr>\n";}
		$i++;
	}
}
$result.="</table><p align=\"right\"><input type=submit value=Remove></p></form></center></font></td></tr>";
$result.=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">ADD CATEGORY</font>
<form action="$cgi/adcadm.pl" method="post">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="addcateg">
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td width="40%"><font size=1><b>Category name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="categ"></font></td></tr>
<tr><td width="40%"><font size=1><b>Subcategory name</b></font></td><td width="60%" align="right"><font size=2><input type="text" size=48 name="subcateg"></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Add category"></td></tr>
</table></form>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub category
{
open(F,"+<$basepath/category.db");
flock(F,$LOCK_EX);
@categ=<F>;
foreach(@categ)
{
	chop;
	next if ($data{target}=~/$_/);
	push(@ncateg,"$_\n");
}
truncate (F,0);
seek (F,0,0);
print F @ncateg;
flock(F,$LOCK_UN);
close(F);
open(F,"+<$adcpath/index.html");
flock(F,$LOCK_EX);
@page=<F>;
foreach (@page)
{
	$flag=0 if ($_ eq "<!--ENDCATEGORIES-->\n");
	push(@npage,$_) if (!$flag);
	if ($_ eq "<!--CATEGORIES-->\n")
	{
		$flag=1;
		foreach $ncateg(@ncateg)
		{
			push(@npage,"<option>$ncateg");
		}
	}
}
truncate (F,0);
seek (F,0,0);
print F @npage;
flock(F,$LOCK_UN);
close(F);
@npage=();
open(F,"+<$adcpath/join.html");
flock(F,$LOCK_EX);
@page=<F>;
foreach (@page)
{
	$flag=0 if ($_ eq "<!--ENDCATEGORIES-->\n");
	push(@npage,$_) if (!$flag);
	if ($_ eq "<!--CATEGORIES-->\n")
	{
		$flag=1;
		foreach $ncateg(@ncateg)
		{
			push(@npage,"<option>$ncateg");
		}
	}
}
truncate (F,0);
seek (F,0,0);
print F @npage;
flock(F,$LOCK_UN);
close(F);
&tasman;
}
sub addcateg
{
open(F,"+<$basepath/category.db");
flock(F,$LOCK_EX);
@categ=<F>;
push(@categ,"$data{categ}:$data{subcateg}\n");
@categ=sort(@categ);
truncate (F,0);
seek (F,0,0);
print F @categ;
flock(F,$LOCK_UN);
close(F);
open(F,"+<$adcpath/index.html");
flock(F,$LOCK_EX);
@page=<F>;
foreach (@page)
{
	$flag=0 if ($_ eq "<!--ENDCATEGORIES-->\n");
	push(@npage,$_) if (!$flag);
	if ($_ eq "<!--CATEGORIES-->\n")
	{
		$flag=1;
		foreach $ncateg(@categ)
		{
			push(@npage,"<option>$ncateg");
		}
	}
}
truncate (F,0);
seek (F,0,0);
print F @npage;
flock(F,$LOCK_UN);
close(F);
@npage=();
open(F,"+<$adcpath/join.html");
flock(F,$LOCK_EX);
@page=<F>;
foreach (@page)
{
	$flag=0 if ($_ eq "<!--ENDCATEGORIES-->\n");
	push(@npage,$_) if (!$flag);
	if ($_ eq "<!--CATEGORIES-->\n")
	{
		$flag=1;
		foreach $ncateg(@categ)
		{
			push(@npage,"<option>$ncateg");
		}
	}
}
truncate (F,0);
seek (F,0,0);
print F @npage;
flock(F,$LOCK_UN);
close(F);
&tasman;
}
sub checkurl
{
if ($uselwp)
{
	$spiderscript="adcspiderlwp.pl";
}
else
{
	$spiderscript="adcspider.pl";
}
srand;
$random=rand;
$result=qq~
<script language=javascript>
window.open("$cgi/$spiderscript?name=$data{name}&password=$data{password}&random=$random");
</script>
<tr><td width="450">
<font size=5 color="#00B0B0">URL CHECKING</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td><font size=1><b>This process can take several minutes in dependance how much members do you have. Please, track progress in new opened window.</b></font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub dbman
{
$status.="Backup system status:<br>";
if ($usetar)
{
	$status.="Archive::Tar module is enabled.<br>";
}
else
{
	$status.="<font color=red>Archive::Tar module is disabled. Backup system require this module to work. Before enabling it at the General Settings - consult with your hosting provider if this module is installed on your server.</font><br>";
}
if ($usezlib)
{
	$status.="Compress::Zlib module is enabled.<br>";
}
else
{
	$status.="<font color=red>Compress::Zlib module is disabled. Without this module enabled backup system can create only non-compressed backups. Before enabling it at the General Settings - consult with your hosting provider if this module is installed on your server.</font><br>";
}
opendir(Dir,"$basepath");
@fdata=readdir(Dir);
closedir(Dir);
shift(@fdata);
shift(@fdata);
@fdata=sort({$b<=>$a}@fdata);
foreach(@fdata){if ($_=~/\.tar\.gz$/ || $_=~/\.tar$/){$bups.=qq~<option value="$_">$_</option>\n~;}}
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">BULK ACCOUNT REMOVAL</font>
<form method="post" action="$cgi/adcadm.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="bulkremove">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="35%"><font size="2"><b>Choose to remove</b></font></td>
<td width="65%"><select name="type"><option value="inactive">All inactive accounts</option><option value="all">All accounts</option></select></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Do it"></td></tr>
</table></form></td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">BACKUP DATABASES</font>
<form action="$cgi/adcadm.pl" method="post">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="backup_data">
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td colspan=2 align="right"><font size=2>$status</font></td></tr>
<tr><td width="40%"><font size=1><b>Create backup file</b></font></td><td width="60%" align="right"><font size=2><input type="submit" value="Do it"></font></td></tr>
</table></form>
</td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">INSTALL BACKUP</font>
<form action="$cgi/adcadm.pl" method="post">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="install_backup">
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td width="40%"><font size=1><b>Choose backup file to install</b></font></td><td width="60%" align="right"><font size=2><select name=fname>$bups</select></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Do it"></td></tr>
</table></form>
</td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">DELETE BACKUP FILE</font>
<form action="$cgi/adcadm.pl" method="post">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="delete_backup">
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td width="40%"><font size=1><b>Choose backup file to delete</b></font></td><td width="60%" align="right"><font size=2><select name=fname>$bups</select></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Do it"></td></tr>
</table></form>
</td></tr>
~;
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
if ($usetar)
{
	$command='use Archive::Tar;';
	eval($command);
	chdir("$basepath");
	unless (-e "./adcenter.pwd")
	{
		$status="<font color=red>Backup operation failed. Cant set $basepath as current directory.</font>\n";
		&dbman;
	}
	opendir(Dir,"./");
	@fdata=readdir(Dir);
	closedir(Dir);
	shift(@fdata);
	shift(@fdata);
	foreach(@fdata)
	{
		if (-d "$_")
		{
			push(@dirs,"$_");
		}
		elsif ($_=~/\.tar\.gz$/ || $_=~/\.tar$/){next;}
		else {push (@files,"$_");}
	}
	foreach(@dirs)
	{
		opendir(Dir,"$_");
		@fdata=readdir(Dir);
		closedir(Dir);
		shift(@fdata);
		shift(@fdata);
		foreach $file(@fdata)
		{
			push (@files,"$_/$file");
		}
	}
	($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
	$lmon=$cal{$month};
	$ldte=$date;
	$lmon="0".$lmon if (length($lmon)==1);
	$ldte="0".$date if (length($date)==1);
	$filen="$year$lmon$ldte";
	$tar = Archive::Tar->new();
	$tar->add_files(@files);
	if ($usezlib)
	{
		$tar->write("$filen.tar.gz",1);
	}
	else
	{
		$tar->write("$filen.tar",0);
	}
}
&dbman;
}
sub delete_backup
{
unlink("$basepath/$data{fname}");
&dbman;
}
sub install_backup
{
if ($usetar)
{
	$command='use Archive::Tar;';
	eval($command);
	chdir("$basepath");
	unless (-e "./adcenter.pwd")
	{
		$status="<font color=red>Install backup operation failed. Cant set $basepath as current directory.</font>\n";
		&dbman;
	}
	$tar = Archive::Tar->new();
	if ($data{fname}=~/\.tar\.gz$/)
	{
		$tar->read("$data{fname}",1);
	}
	elsif ($data{fname}=~/\.tar$/)
	{
		$tar->read("$data{fname}",0);
	}
	@files=$tar->list_files();
	$tar->extract(@files);
}
&dbman;
}
sub bulkremove
{
if ($data{type} eq "all")
{
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">BULK ACCOUNT REMOVAL</font>
<form method="post" action="$cgi/adcadm.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="bulkremove_c"><input type="hidden" name="type" value="all">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td><font size="2" color=red><b>ARE YOU SURE TO REMOVE ALL ACCOUNTS FROM SYSTEM?</b></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Do it"></td></tr>
</table></form></td></tr>
~;
}
elsif ($data{type} eq "inactive")
{
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">BULK ACCOUNT REMOVAL</font>
<form method="post" action="$cgi/adcadm.pl">
<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="bulkremove_c"><input type="hidden" name="type" value="inactive">
<table bgcolor="#00B0B0" border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td><font size="2" color=red><b>ARE YOU SURE TO REMOVE ALL INACTIVE ACCOUNTS FROM SYSTEM?</b></font></td></tr>
<tr><td colspan=2 align="right"><input type="submit" value="Do it"></td></tr>
</table></form></td></tr>
~;
}
open (F,"<$adcpath/template/adm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub bulkremove_c
{
if ($data{type} eq "inactive")
{
	open (F, "+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		($username)=split("\t",$line);
		if ((-M "$basepath/$username/lastact">$inactive_limit || (-M "$basepath/$username/join">$inactive_limit && !(-e "$basepath/$username/lastact"))) && $username ne $yourname){push(@ustorem,$username);next;}
		push(@db,$line);
	}
	truncate(F,0);
	seek(F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	@db=();
	open (F, "+<$basepath/adcenter.srh");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		($username)=split("\t",$line);
		if ((-M "$basepath/$username/lastact">$inactive_limit || (-M "$basepath/$username/join">$inactive_limit && !(-e "$basepath/$username/lastact"))) && $username ne $yourname){next;}
		push(@db,$line);
	}
	truncate(F,0);
	seek(F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	@db=();
	open (F, "+<$basepath/global");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		($username)=split("\t",$line);
		if ((-M "$basepath/$username/lastact">$inactive_limit || (-M "$basepath/$username/join">$inactive_limit && !(-e "$basepath/$username/lastact"))) && $username ne $yourname){next;}
		push(@db,$line);
	}
	truncate(F,0);
	seek(F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	@db=();
	open (F, "+<$basepath/adcenter.bup");
	flock(F,$LOCK_EX);
	while($line=<F>)
	{
		($garb,$username)=split("\t",$line);
		if ((-M "$basepath/$username/lastact">$inactive_limit || (-M "$basepath/$username/join">$inactive_limit && !(-e "$basepath/$username/lastact"))) && $username ne $yourname){next;}
		push(@db,$line);
	}
	truncate(F,0);
	seek(F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	foreach(@ustorem)
	{
		$encus=crypt($_,$_);
		@db=();
		open (F, "+<$basepath/adcenter.pwd");
		flock(F,$LOCK_EX);
		@realus=<F>;
		foreach $real(@realus)
		{
			($eus)=split(":",$real);
			next if ($eus eq $encus);
			push(@db,$real);
		}
		truncate(F,0);
		seek(F,0,0);
		print F @db;
		flock(F,$LOCK_UN);
		close(F);
		opendir(Dir,"$basepath/$_");
		@files=readdir(Dir);
		closedir(Dir);
		foreach $file(@files)
		{
			unlink("$basepath/$_/$file");
		}
		rmdir("$basepath/$_");
	}
}
elsif ($data{type} eq "all")
{
	opendir(Dir,"$basepath");
	@files=readdir(Dir);
	closedir(Dir);
	shift(@files);
	shift(@files);
	foreach (@files)
	{
		if (-d "$basepath/$_")
		{
			opendir(Dir,"$basepath/$_");
			@filez=readdir(Dir);
			closedir(Dir);
			foreach $file(@filez)
			{
				unlink("$basepath/$_/$file");
			}
			rmdir("$basepath/$_");
		}
	}
	open (F,">$basepath/adcenter.db");
	close (F);
	open (F,">$basepath/adcenter.srh");
	close (F);
	open (F,">$basepath/adcenter.bup");
	close (F);
	open (F,">$basepath/global");
	close (F);
	open (F,">$basepath/maillist");
	close (F);
	open (F, "+<$basepath/adcenter.pwd");
	flock(F,$LOCK_EX);
	@realus=<F>;
	$adm_data=shift(@realus);
	truncate(F,0);
	seek(F,0,0);
	print F $adm_data;
	flock(F,$LOCK_UN);
	close(F);
}
&dbman;
}
