#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@digits = ("3c 7e 66 66 66 66 66 66 7e 3c","60 70 78 60 60 60 60 60 60 60","3c 7e 66 66 60 30 18 0c 7e 7e","3c 7e 66 60 30 30 60 66 7e 3c","60 70 78 6c 66 66 7e 7e 60 60","7e 7e 06 3e 7e 60 60 60 7e 3e","7c 7e 06 3e 7e 66 66 66 7e 3c","7e 7e 60 30 18 0c 0c 0c 0c 0c","3c 7e 66 66 3c 7e 66 66 7e 3c","3c 7e 66 66 66 7e 7c 60 7e 3e");
open (F,"<$basepath/$ENV{QUERY_STRING}/counter");
flock(F,$LOCK_EX);
$count=<F>;
flock(F,$LOCK_UN);
close (F);
$len=8;
$counter = sprintf("%0${len}d",$count);
for ($y=0; $y < 10; $y++)
{
	for ($x=0; $x < $len; $x++){push(@bytes,substr(@digits[substr($counter,$x,1)],$y*3,2));}
}
print "Content-type: image/x-xbitmap\n\n";
print "#define count_width 64\n#define count_height 10\n";
print "static char count_bits[] = {\n";
for($i = 0; $i < ($#bytes + 1); $i++)
{
	print("0x$bytes[$i]");
	if ($i != $#bytes){print(",");if (($i+1) % 7 == 0){print("\n");}}
}
print("};\n");
