#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@header=("ff","ff","ff","ff","ff","ff","ff","ff","ff","ff","01","00","00","00","00","00","00","00","00","80","01","30","fc","80","0f","00","c0","00","00","80","01","70","fc","e3","0f","00","e0","00","00","80","01","78","9c","e3","0c","00","e0","00","00","80","01","f8","1c","77","d8","f7","f3","f3","fd","80","01","fc","1c","77","e0","ff","f7","fb","7f","80","01","dc","1d","77","70","77","e7","dc","1d","80","01","fe","1d","77","f0","71","e7","7c","1c","80","01","fe","9f","e3","7c","76","e7","9c","1d","80","01","8f","ff","e3","ef","7f","e7","fb","1f","80","01","87","ff","80","cf","77","c7","f3","1d","80","01","00","00","00","00","00","00","00","00","80","01","00","00","00","00","00","00","00","00","80","fd","ff","ff","ff","ff","ff","ff","ff","ff","bf","fd","ff","ff","ff","ff","ff","ff","ff","ff","bf","fd","ff","ff","ff","ff","ff","ff","ff","ff","bf");
@digits = ("c3 81 99 99 99 99 99 99 81 c3","9f 8f 87 9f 9f 9f 9f 9f 9f 9f","c3 81 99 99 9f cf e7 f3 81 81","c3 81 99 9f cf cf 9f 99 81 c3","9f 8f 87 93 99 99 81 81 9f 9f","81 81 f9 c1 81 9f 9f 9f 81 c1","83 81 f9 c1 81 99 99 99 81 c3","81 81 9f cf e7 f3 f3 f3 f3 f3","c3 81 99 99 c3 81 99 99 81 c3","c3 81 99 99 99 81 83 9f 81 c1");
@footer=("fd","ff","ff","ff","ff","ff","ff","ff","ff","bf","fd","ff","ff","ff","ff","ff","ff","ff","ff","bf","01","00","00","00","00","00","00","00","00","80","01","00","00","0f","1e","3c","78","00","00","80","01","00","80","1f","3f","7e","fc","00","00","80","01","00","c0","b9","7f","ff","fe","01","00","80","01","00","c0","b9","73","e7","ce","01","00","80","01","00","c0","bb","73","e7","ce","01","00","80","01","00","80","9d","73","e7","ce","01","00","80","01","00","00","9e","73","e7","ce","01","00","80","01","00","00","8f","7f","ff","fe","01","00","80","01","00","80","bf","3f","7e","fc","00","00","80","01","00","c0","3f","1e","3c","78","00","00","80","01","00","00","00","00","00","00","00","00","80","ff","ff","ff","ff","ff","ff","ff","ff","ff","ff");
open (F,"+<$basepath/$ENV{QUERY_STRING}/counter");
flock(F,$LOCK_EX);
$count=<F>;
$count++;
truncate (F,0);
seek (F,0,0);
print F $count;
flock(F,$LOCK_UN);
close (F);
open (F,"+<$basepath/$ENV{QUERY_STRING}/visitors");
flock(F,$LOCK_EX);
$visitors=<F>;
unless ($visitors=~/$ENV{REMOTE_ADDR}/){print F " $ENV{REMOTE_ADDR}";}
flock(F,$LOCK_UN);
close (F);
$len=8;
$counter = sprintf("%0${len}d",$count);
@bytes=@header;
for ($y=0; $y < 10; $y++)
{
	push(@bytes,"fd");
	for ($x=0; $x < $len; $x++){push(@bytes,substr(@digits[substr($counter,$x,1)],$y*3,2));}
	push(@bytes,"bf");
}
foreach(@footer){push(@bytes,$_);}
print "Content-type: image/x-xbitmap\n\n";
print "#define count_width 80\n#define count_height 42\n";
print "static char count_bits[] = {\n";
for($i = 0; $i < ($#bytes + 1); $i++)
{
	print("0x$bytes[$i]");
	if ($i != $#bytes){print(",");if (($i+1) % 7 == 0){print("\n");}}
}
print("};\n");
