#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$check=$furl;
$check=~s/http:\/\///;
($check,@garb)=split("/",$check);
unless ($ENV{HTTP_REFERER}=~/$check/)
{
	print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
	print "Location: $furl\n\n";
}

if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
$start=$data{start};
@data=();
open (F,"<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@data=<F>;
flock(F,$LOCK_UN);
close(F);
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>10)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcglst.pl?start=$pstart\"><img src=\"$adcenter/images/prev.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");
	if ($start*10+10<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/adcglst.pl?start=$nstart\"><img src=\"$adcenter/images/next.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=1><b>$icount MEMBERS IN DATABASE</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*10+10>scalar(@data))
{
	$i=$start*10;
	while($i<scalar(@data))
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		open (F,"<$basepath/$user/credits");
		flock(F,$LOCK_EX);
		@creds=<F>;
		flock(F,$LOCK_UN);
		close(F);
		($impcrd,$clccrd)=split("\t",$creds[0]);
		push(@result,"<li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a><br><font size=\"2\"><b>URL:</b> <a href=\"$userurl\" target=\"_blank\">$userurl</a></font><br><font size=1><b>Ratio:</b> $oratio<br><b>Unused credits (IMP/CLC):</b> $impcrd/$clccrd</li>\n");
		$i++;
	}
}
else
{
	$i=$start*10;
	$last=$i+10;
	while($i<$last)
	{
		($user,$userurl,$group,$oratio,$ref)=split("\t",$data[$i]);
		open (F,"<$basepath/$user/credits");
		flock(F,$LOCK_EX);
		@creds=<F>;
		flock(F,$LOCK_UN);
		close(F);
		($impcrd,$clccrd)=split("\t",$creds[0]);
		push(@result,"<li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$user&method=userinfo\" target=\"_blank\">$user</a><br><font size=\"2\"><b>URL:</b> <a href=\"$userurl\" target=\"_blank\">$userurl</a></font><br><font size=1><b>Ratio:</b> $oratio<br><b>Unused credits (IMP/CLC):</b> $impcrd/$clccrd</li>\n");
		$i++;
	}
}
if (!@result)
{
	push(@result,"<li>Empty database</li>");
}
open (F,"<$adcpath/template/ulst.tpl");
@html=<F>;
close (F);
$html=join("\n",@html);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;

sub errauth
{
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
