#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$check=$furl;
$check=~s/http:\/\///;
($check,@garb)=split("/",$check);
unless ($ENV{HTTP_REFERER}=~/$check/)
{
	print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
	print "Location: $furl\n\n";
}

if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
$encline=crypt($data{name},$data{name}).":";
$destination=$data{method};

open (F, "<$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
@pass=<F>;
flock(F,$LOCK_UN);
close (F);
shift(@pass);
foreach (@pass)
{
	chop;
	&$destination if ($_=~/$encline/);
}
open (F,"<$adcpath/template/errname.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;

sub userinfo
{
open (F, "<$basepath/$data{name}/lastact");
flock(F,$LOCK_EX);
@lastact=<F>;
flock(F,$LOCK_UN);
close (F);
$lastact=substr($lastact[0],4,2).".".substr($lastact[0],6,2).".".substr($lastact[0],0,4);
open (F, "<$basepath/global");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@dta)
{
	chop;
	($user,$name,$address,$city,$zip,$country,$phone,$uemail)=split("\t",$_);
	if ($user eq $data{name})
	{
		$flag=1;
		last;
	}
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@dta)
{
	chop;
	($user,$userurl)=split("\t",$_);
	if ($user eq $data{name}){last;}
}
if (!$flag)
{
	$user="Nothing in DB";
	$name="Nothing in DB";
	$address="Nothing in DB";
	$city="Nothing in DB";
	$zip="Nothing in DB";
	$country="Nothing in DB";
	$phone="Nothing in DB";
	$uemail="Nothing in DB";
}
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">USER INFORMATION</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Username</b></font></td><td width="60%" align="right"><font size=2><b>$data{name}</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Realname</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$name</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Address</b></font></td><td width="60%" align="right"><font size=2>$address</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>City</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$city</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Zip code</b></font></td><td width="60%" align="right"><font size=2>$zip</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Country</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$country</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Phone</b></font></td><td width="60%" align="right"><font size=2>$phone</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Email</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$uemail</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Last activity</b></font></td><td width="60%" align="right"><font size=2>$lastact</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>URL</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2><a href="$userurl" target="_blank">$userurl</a></font></td></tr>
~;
if (-e "$adcpath/banners/$data{name}.gif")
{
	$result.=qq~<tr><td colspan=2 align="center"><img src="$adcenter/banners/$data{name}.gif" width=430 height=55></td></tr>~;
}
if ($uemail ne "Nothing in DB")
{
	$result.=qq~<tr><td colspan=2 align="center"><form action="$cgi/adcgnfo.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="method" value="mail"><input type="hidden" name="uemail" value="$uemail"><font color=red size=2><b>Subject: </b><input type="text" name="subject" size=49><br><textarea name="body" cols=50 rows=5></textarea><br><input type="submit" value="SEND MAIL"></font></form></td></tr></table></td></tr>~;
}
else
{
	$result.=qq~</table></td></tr>~;
}
open (F,"<$adcpath/template/admmem.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub genstats
{
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@dta)
{
	($username,$url,$usrgroup,$uratio,$referuser)=split("\t",$_);
	last if ($username eq $data{name})
}
open (F,"<$basepath/$data{name}/banner");
flock(F,$LOCK_EX);
@bannerdate=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$basepath/$data{name}/reset");
flock(F,$LOCK_EX);
@resetdate=<F>;
flock(F,$LOCK_UN);
close(F);
($b1,$b2,$b3)=split(" ",$bannerdate[0]);
($r1,$r2,$r3)=split(" ",$resetdate[0]);
$b1=$cal{$b1};
$r1=$cal{$r1};
open (STAT,"<$basepath/$data{name}/impressions");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	($n1,$n2,$n3,$n4)=split(" ",$tkey);
	$n2=$cal{$n2};
	@temp=split("#",$tval);
	foreach(@temp){$genimp+=$_;$banimp+=$_ if ($b3<$n4 || ($b1<$n2 && $b3==$n4) || ($b1==$n2 && $b2<=$n3 && $b3==$n4));$resimp+=$_ if ($r3<$n4 || ($r1<$n2 && $r3==$n4) || ($r1<=$n2 && $r2<=$n3 && $r3<=$n4))}
}
flock(STAT,$LOCK_UN);
close (STAT);
open (STAT,"<$basepath/$data{name}/clicks");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	($n1,$n2,$n3,$n4)=split(" ",$tkey);
	$n2=$cal{$n2};
	@temp=split("#",$tval);
	foreach(@temp){$genclc+=$_;$banclc+=$_ if ($b3<$n4 || ($b1<$n2 && $b3==$n4) || ($b1==$n2 && $b2<=$n3 && $b3==$n4));$resclc+=$_ if ($r3<$n4 || ($r1<$n2 && $r3==$n4) || ($r1<=$n2 && $r2<=$n3 && $r3<=$n4))}
}
flock(STAT,$LOCK_UN);
close (STAT);
open (F,"<$basepath/$data{name}/credits");
flock(F,$LOCK_EX);
@credits=<F>;
flock(F,$LOCK_UN);
close(F);
($impres,$cli)=split("\t",$credits[0]);
open (F,"<$basepath/$data{name}/lastimp");
flock(F,$LOCK_EX);
@lastimp=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$basepath/$data{name}/lastclc");
flock(F,$LOCK_EX);
@lastclc=<F>;
flock(F,$LOCK_UN);
close(F);
chop($lastimp[0]);
chop($lastimp[1]);
chop($lastclc[0]);
chop($lastclc[1]);
open (F,"<$basepath/$data{name}/banner");
flock(F,$LOCK_EX);
@bannerdate=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$basepath/$data{name}/reset");
flock(F,$LOCK_EX);
@resetdate=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,"<$basepath/$data{name}/join");
flock(F,$LOCK_EX);
@joindate=<F>;
flock(F,$LOCK_UN);
close(F);
$genimp=0 if ($genimp eq "");
$genclc=0 if ($genclc eq "");
$banimp=0 if ($banimp eq "");
$banclc=0 if ($banclc eq "");
$resimp=0 if ($resimp eq "");
$resclc=0 if ($resclc eq "");
$lastclc[1]="N/A" if ($lastclc[1] eq "");
$lastimp[1]="N/A" if ($lastimp[1] eq "");
if ($genimp!=0){$genrat=$genclc/$genimp;}
else {$genrat=0;}
if ($banimp!=0){$banrat=$banclc/$banimp;}
else {$banrat=0;}
if ($resimp!=0){$resrat=$resclc/$resimp;}
else {$resrat=0;}
if ($uratio>1){$uratio="1:$uratio";}
elsif ($uratio<1 && $uratio>0)
{
	$uratio=1/$uratio;
	if ($uratio>=2){$uratio=int($uratio).":1";}
	elsif ($uratio>=1.5){$uratio="3:2";}
	elsif ($uratio>=1.3){$uratio="4:3";}
	else {$uratio="$uratio:1";}
}
if ($refratio>1){$refratio="1:$refratio";}
elsif ($refratio<1 && $refratio>0)
{
	$refratio=int(1/$refratio);
	if ($refratio>=2){$refratio=int($refratio).":1";}
	elsif ($refratio>=1.5){$refratio="3:2";}
	elsif ($refratio>=1.3){$refratio="4:3";}
	else {$refratio="$refratio:1";}
}
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">SINCE JOINING</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Joining date</b></font></td><td width="60%" align="right"><font size=2><b>$joindate[0]</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$genimp</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right"><font size=2>$genclc</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Click Through Ratio</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$genrat</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">FOR CURRENT BANNER</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Banner was uploaded at</b></font></td><td width="60%" align="right"><font size=2><b>$bannerdate[0]</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$banimp</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right"><font size=2>$banclc</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Click Through Ratio</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$banrat</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">SINCE LAST RESET</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Last reset at</b></font></td><td width="60%" align="right"><font size=2><b>$resetdate[0]</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$resimp</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right"><font size=2>$resclc</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Click Through Ratio</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$resrat</font></td></tr>
<tr><td colspan=2 align="right"><form action="$cgi/adcmem.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="reset"><input type="submit" value="RESET STATS"></form></td></tr>
</table>
</td></tr>
<tr><td width="450">
<font size=5 color="#00B0B0">CREDITS INFO</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Unused impression credits</b></font></td><td width="60%" align="right"><font size=2>$impres</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Unused click credits</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$cli</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Last added impression credits</b></font></td><td width="60%" align="right"><font size=2>$lastimp[0] ($lastimp[1])</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Last added click credits</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$lastclc[0] ($lastclc[1])</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Exchange ratio</b></font></td><td width="60%" align="right"><font size=2>$uratio</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Referal ratio</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$refratio</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/admmem.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub hourstats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
open (STAT,"<$basepath/$data{name}/impressions");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	if ($tkey=~/ $date / && $tkey=~/ $month / && $tkey=~/ $year/)
	{
	@dimp=split("#",$tval);
	foreach(@dimp){$totimp+=$_;}
	}
}
flock(STAT,$LOCK_UN);
close (STAT);
open (STAT,"<$basepath/$data{name}/clicks");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	if ($tkey=~/ $date / && $tkey=~/ $month / && $tkey=~/ $year/)
	{
	@dclc=split("#",$tval);
	foreach(@dclc){$totclc+=$_;}
	}
}
flock(STAT,$LOCK_UN);
close (STAT);
$i=0;
while ($i<24){$dimp[$i]=0 unless ($dimp[$i]);$i++;}
$i=0;
while ($i<24){$dclc[$i]=0 unless ($dclc[$i]);$i++;}
@mdimp=@dimp;
@mdimp=sort ({$b<=>$a} @mdimp);
$maximp=shift(@mdimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">HOURLY STATS</font>
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions today: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@dimp)
{
	$height=int($_/$grat);
	$result.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
@mdclc=@dclc;
@mdclc=sort ({$b<=>$a} @mdclc);
$maxclc=shift(@mdclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks today: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@dclc)
{
	$height=int($_/$grat);
	$result.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
$result.=qq~
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Time</b></font></td><td width="30%" align="right"><font size=2><b>Impressions</b></font></td><td width="30%" align="right"><font size=2><b>Clicks</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>12:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[0]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[0]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>1:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[1]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[1]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>2:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[2]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[2]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>3:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[3]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[3]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>4:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[4]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[4]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>5:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[5]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[5]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>6:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[6]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[6]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>7:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[7]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[7]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>8:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[8]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[8]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>9:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[9]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[9]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>10:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[10]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[10]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>11:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[11]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[11]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>12:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[12]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[12]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>1:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[13]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[13]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>2:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[14]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[14]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>3:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[15]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[15]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>4:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[16]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[16]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>5:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[17]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[17]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>6:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[18]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[18]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>7:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[19]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[19]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>8:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[20]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[20]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>9:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[21]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[21]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>10:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[22]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[22]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>11:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[23]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[23]</font></td></tr>
<tr><td colspan=3><font color=red size=1>hourly stats for <b>$data{name}</b> ($ldate)</font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/admmem.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub daystats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
open (STAT,"<$basepath/$data{name}/impressions");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	if ($tkey=~/ $month / && $tkey=~/ $year/)
	{
	$tkey=~s/  / /;
	($faf,$fae,$fas)=split(" ",$tkey);
	@dimp=split("#",$tval);
	foreach(@dimp){$totimp+=$_;$mimp[$fas]+=$_;}
	}
}
flock(STAT,$LOCK_UN);
close (STAT);
open (STAT,"<$basepath/$data{name}/clicks");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	if ($tkey=~/ $month / && $tkey=~/ $year/)
	{
	$tkey=~s/  / /;
	($faf,$fae,$fas)=split(" ",$tkey);
	@dimp=split("#",$tval);
	foreach(@dimp){$totclc+=$_;$mclc[$fas]+=$_;}
	}
}
flock(STAT,$LOCK_UN);
close (STAT);
$calendar{$month}=29 if ($year/4-int($year/4)==0 && $month eq "Feb");
$tablewidth=12*$calendar{$month}-2;
$table=$tablewidth+60;
$i=1;
while($i<$calendar{$month}+1)
{
	$mclc[$i]=0 if ($mclc[$i] eq "");
	$mimp[$i]=0 if ($mimp[$i] eq "");
	push(@mstats,"<tr><td bgcolor=\"#C0C0C0\"><font size=2><b>$i</b></font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$mimp[$i]</font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$mclc[$i]</font></td></tr>\n");
	$i++;
}
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">DAILY STATS</font>
~;
@mmimp=@mimp;
@mmimp=sort ({$b<=>$a} @mmimp);
$maximp=shift(@mmimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions in this month: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($mimp[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
@mmclc=@mclc;
@mmclc=sort ({$b<=>$a} @mmclc);
$maxclc=shift(@mmclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks in this month: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($mclc[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
$result.=qq~
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Date</b></font></td><td width="30%" align="right"><font size=2><b>Impressions</b></font></td><td width="30%" align="right"><font size=2><b>Clicks</b></font></td></tr>
@mstats
<tr><td colspan=3><font color=red size=1>daily stats for <b>$data{name}</b> ($month $year)</font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/admmem.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub mail
{
	open (MAIL,"|$progmail");
	print MAIL "To: $data{uemail}\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: $data{subject}\n\n";
	print MAIL "$data{body}\n\n";
	close (MAIL);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SENDMAIL STATUS</font>
	<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
	<tr><td><font size=2>Mail was sent to $data{name}</font></td></tr>
	</table></td></tr>~;
	open (F,"<$adcpath/template/admmem.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}

sub errauth
{
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub affiliate
{
if (-e "$basepath/$data{name}/adate")
{
open (F, "<$basepath/$data{name}/adate");
flock(F,$LOCK_EX);
$adate=<F>;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F, "<$basepath/$data{name}/join");
flock(F,$LOCK_EX);
$adate=<F>;
flock(F,$LOCK_UN);
close (F);
}
open (F, "<$basepath/$data{name}/affiliate");
flock(F,$LOCK_EX);
@dta=<F>;
flock(F,$LOCK_UN);
close (F);
@dta=sort(@dta);
foreach(@dta)
{
	chop;
	($username,$url,$imp,$clc)=split("\t",$_);
	push (@res,qq~<tr><td width="60%" bgcolor="#C0C0C0" valign="top"><font size=1><b>$username ($url)</b></font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$imp</font></td><td width="20%" align="right" bgcolor="#C0C0C0"><font size=2>$clc</font></td></tr>\n~);
}
push (@res,qq~<tr><td width="60%" bgcolor="#C0C0C0" valign="top" colspan=3>No stats</td></tr>\n~) if (!@res);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">EXTENDED STATS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="60%" valign="top"><font size=2><b>Banner was showed at</b></font></td><td width="20%" align="right"><font size=2><b>Impressions</b></font></td><td width="20%" align="right"><font size=2><b>Clicks</b></font></td></tr>
@res
<tr><td colspan=3><font size=1><b>Stats since $adate</td></tr>
<tr><td colspan=3><form action="$cgi/adcgnfo.pl" method=post><input type=hidden name=name value=$data{name}><input type=hidden name=password value=$data{password}><input type=hidden name=method value=clearestats><input type=submit value="Reset Stats"></form></td></tr>
</table></td></tr>
~;
open (F,"<$adcpath/template/admmem.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub clearestats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
unlink("$basepath/$data{name}/affiliate");
open (F,">$basepath/$data{name}/adate");
flock(F,$LOCK_EX);
print F $ldate;
flock(F,$LOCK_UN);
close(F);
&affiliate;
}
