#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
if (!$data{EMail})
{
	push (@errors,"Please enter your email<br>\n");
	open (F,"<$adcpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
open (F,"<$basepath/adcenter.bup");
flock(F,$LOCK_EX);
@users=<F>;
flock(F,$LOCK_UN);
close (F);
foreach (@users)
{
	($emls,$user,$password)=split("\t",$_);
	if ($data{EMail} eq $emls)
	{
		open(F,"<$adcpath/mail/pass.hdr");
		@header=<F>;
		close(F);
		open(F,"<$adcpath/mail/pass.btm");
		@bottom=<F>;
		close(F);
		open (MAIL,"|$progmail");
		print MAIL "To: $data{EMail}\n";
		print MAIL "From: $email ($owntitle)\n";
		print MAIL "Subject: Password request\n\n";
		print MAIL @header;
		print MAIL "Login: $user\nPassword: $password\n\n";
		print MAIL @bottom;
		close (MAIL);
		open (F,"<$adcpath/template/pass.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("\n",@htmlpage);
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
        }
}
push (@errors,"Your email is not exist in our database<br>\n");
open (F,"<$adcpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
