#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field}##$value";}
		else {$data{$field}=$value;}
	}
}
$data{name}=substr($data{name},0,8) if (length($data{name})>8);
if ($data{method} eq "target")
{
	open(F,">$basepath/$data{name}/target");
	flock(F,$LOCK_EX);
	print F $data{target};
	flock(F,$LOCK_UN);
	close(F);
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">TARGET SITES MANAGEMENT</font><br>
	<font size=2><center>
	<form action="$cgi/adcmem.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="target">
	<table bgcolor="#00B0B0" width="100%">
	~;
	open(F,"<$basepath/category.db");
	flock(F,$LOCK_EX);
	@categ=<F>;
	flock(F,$LOCK_UN);
	close(F);
	open(F,"<$basepath/$data{name}/target");
	flock(F,$LOCK_EX);
	@target=<F>;
	flock(F,$LOCK_UN);
	close(F);
	foreach(@categ)
	{
		chop;
		/([^:]+):(.*)/ && do
		{
			($field,$value)=($1,$2);
			$value=~s/\+/ /g;
			$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
			if ($categ{$field}){$categ{$field}="$categ{$field}##$value";}
			else {$categ{$field}=$value;}
		}
	}
	foreach $key (keys %categ)
	{
		$result.="<tr><td colspan=2><font size=2><b>$key</b></font></td></tr>";
		@temp=split("##",$categ{$key});
		foreach(@temp)
		{
			if ($target[0]=~/$key\:$_/)
			{
				$result.="<tr><td width=\"20%\"><input type=checkbox name=target value=\"$key:$_\" checked></td><td width=\"80%\"><font size=2>$_</font></td></tr>\n";
			}
			else {$result.="<tr><td width=\"20%\"><input type=checkbox name=target value=\"$key:$_\"></td><td width=\"80%\"><font size=2>$_</font></td></tr>\n";}
		}
	}
	$result.="</table><p align=\"right\"><input type=submit value=Proceed></p></form></center></font></td></tr>";
	open (F,"<$adcpath/template/stat.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}	
if ($data{method} eq "general")
{
	$data{keywords}=~s/ //g;
	open(F,"+<$basepath/adcenter.db");
	flock(F,$LOCK_EX);
	@db=<F>;
	foreach (@db)
	{
		($username,$url,$usrgroup,$ratio,$referuser,$userweight)=split("\t",$_);
		$_="$username\t$data{url}\t$data{category}\t$ratio\t$referuser\t$userweight" if ($username eq $data{name});
	}
	truncate (F,0);
	seek (F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	open(F,"+<$basepath/adcenter.srh");
	flock(F,$LOCK_EX);
	@db=<F>;
	foreach (@db)
	{
		($username,$url,$usrgroup,$sitetitle,$description,$keyword)=split("\t",$_);
		$_="$username\t$data{url}\t$data{category}\t$data{sitetitle}\t$data{description}\t$data{keywords}\n" if ($username eq $data{name});
	}
	truncate (F,0);
	seek (F,0,0);
	print F @db;
	flock(F,$LOCK_UN);
	close(F);
	open (F,"<$basepath/category.db");
	flock(F,$LOCK_EX);
	@categ=<F>;
	flock(F,$LOCK_UN);
	close(F);
	open (F,"<$basepath/adcenter.srh");
	flock(F,$LOCK_EX);
	@sinfo=<F>;
	flock(F,$LOCK_UN);
	close(F);
	foreach(@sinfo)
	{
		($username,$url,$usrgroup,$sitetitle,$description,$keyword)=split("\t",$_);
		last if ($username eq $data{name})
	}
	chop($keyword);
	$result=qq~
	<tr><td width="450"><form method="post" action="$cgi/adcmem.pl"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="general">
	<font size=5 color="#00B0B0">GENERAL SETTINGS</font>
	<table border="0" width="100%" bgcolor="#00B0B0" cellspacing="0" cellpadding="0">
	<tr><td width="50%"><font size="2">&nbsp;Site URL</font></td>
	<td width="50%"><input type="text" name="url" size="48" value="$url"></td></tr>
	<tr><td width="50%"><font size="2">&nbsp;Site title</font></td>
	<td width="50%"><input type="text" name="sitetitle" size="48" value="$sitetitle"></td></tr>
	<tr><td width="50%"><font size="2">&nbsp;Site description</font></td>
	<td width="50%"><input type="text" name="description" size="48" value="$description"></td></tr>
	<tr><td width="50%"><font size="2">&nbsp;Keywords</font></td>
	<td width="50%"><input type="text" name="keywords" size="48" value="$keyword"></td></tr>
	<tr><td width="50%"><font size="2">&nbsp;Category</font></td>
	<td width="50%"><select name="category">
	~;
	foreach(@categ)
	{
		chop;
		if ($_ eq $usrgroup)
		{
			$result.="<option selected value=\"$_\">$_</option>\n";
		}
		else {$result.="<option value=\"$_\">$_</option>\n";}
	}
	$result.=qq~
	</select></td></tr>
	<tr><td colspan=2 align="right"><input type="submit" value="Proceed">
	</td></tr>
	</table></form></td></tr>
	~;
	open (F,"<$adcpath/template/stat.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}	
if ($data{method} eq "settime")
{
	open(F,">$basepath/$data{name}/timeman");
	flock(F,$LOCK_EX);
	print F "0\t$data{res0}\n0\t$data{res1}\n0\t$data{res2}\n0\t$data{res3}\n0\t$data{res4}\n0\t$data{res5}\n0\t$data{res6}\n0\t$data{res7}\n0\t$data{res8}\n0\t$data{res9}\n0\t$data{res10}\n0\t$data{res11}\n0\t$data{res12}\n0\t$data{res13}\n0\t$data{res14}\n0\t$data{res15}\n0\t$data{res16}\n0\t$data{res17}\n0\t$data{res18}\n0\t$data{res19}\n0\t$data{res20}\n0\t$data{res21}\n0\t$data{res22}\n0\t$data{res23}\n";
	flock(F,$LOCK_UN);
	close(F);
	open (F,"<$basepath/$data{name}/timeman");
	flock(F,$LOCK_EX);
	@temp=<F>;
	flock(F,$LOCK_UN);
	close(F);
	foreach(@temp)
	{
		chop;
		($first,$second)=split("\t",$_);
		push(@res,$second);
	}
	$result=qq~
	<tr><td width="450">
	<font size=5 color="#00B0B0">SET ADVERTISING TIME</font><br><font size=2>
	Set advertising time for your banner</font>
	<form action="$cgi/adcmem.pl" method="post">
	<input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="settime">
	<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
	<tr><td width="30%" valign="top"><font size=2><b>AM Time</b></font></td><td width="20%"><font size=2><b>Impressions</b></font></td><td width="30%" valign="top"><font size=2><b>PM Time</b></font></td><td width="20%"><font size=2><b>Impressions</b></font></td></tr>
	<tr><td width="30%"><font size=1><b>12:00-01:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res0" value="$res[0]"></font></td><td width="30%"><font size=1><b>12:00-01:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res12" value="$res[12]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>01:00-02:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res1" value="$res[1]"></font></td><td width="30%"><font size=1><b>01:00-02:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res13" value="$res[13]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>02:00-03:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res2" value="$res[2]"></font></td><td width="30%"><font size=1><b>02:00-03:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res14" value="$res[14]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>03:00-04:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res3" value="$res[3]"></font></td><td width="30%"><font size=1><b>03:00-04:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res15" value="$res[15]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>04:00-05:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res4" value="$res[4]"></font></td><td width="30%"><font size=1><b>04:00-05:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res16" value="$res[16]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>05:00-06:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res5" value="$res[5]"></font></td><td width="30%"><font size=1><b>05:00-06:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res17" value="$res[17]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>06:00-07:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res6" value="$res[6]"></font></td><td width="30%"><font size=1><b>06:00-07:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res18" value="$res[18]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>07:00-08:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res7" value="$res[7]"></font></td><td width="30%"><font size=1><b>07:00-08:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res19" value="$res[19]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>08:00-09:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res8" value="$res[8]"></font></td><td width="30%"><font size=1><b>08:00-09:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res20" value="$res[20]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>09:00-10:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res9" value="$res[9]"></font></td><td width="30%"><font size=1><b>09:00-10:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res21" value="$res[21]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>10:00-11:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res10" value="$res[10]"></font></td><td width="30%"><font size=1><b>10:00-11:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res22" value="$res[22]"></font></td></tr>
	<tr><td width="30%"><font size=1><b>11:00-12:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res11" value="$res[11]"></font></td><td width="30%"><font size=1><b>11:00-12:00</b></font></td><td width="20%" align="right"><font size=2><input type="text" name="res23" value="$res[23]"></font></td></tr>
	<tr><td colspan=4 align="right"><input type="submit" value="Proceed"></td></tr>
	</table></form>
	</td></tr>
	~;
	open (F,"<$adcpath/template/stat.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{method} eq "reset")
{
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
open (F,">$basepath/$data{name}/reset");
flock(F,$LOCK_EX);
print F "$month $date $year";
flock(F,$LOCK_UN);
close(F);
$result=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">RESET STATUS</font><br><font size=2>
Set advertising time for your banner</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#00B0B0">
<tr><td><font size=2>Your stats were reset successfully</font></td></tr>
</table>
</td></tr>
~;
open (F,"<$adcpath/template/stat.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
