#!/usr/bin/perl
$SIG{ALRM}=sub {&printres};

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($field eq "target")
		{
		if ($data{$field}){$data{$field}="$data{$field}##$value";}
		else {$data{$field}=$value;}
		}
		else
		{
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
		}
	}
}
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
open (F, "<$basepath/adcenter.pwd");
flock(F,$LOCK_EX);
@pass=<F>;
flock(F,$LOCK_UN);
close (F);
chop($admpass=shift(@pass));
&errauth if ($admpass ne $encline);
open (F,"<$adcpath/temp/count");
flock(F,$LOCK_EX);
$count=<F>;
flock(F,$LOCK_UN);
close (F);
open (F,"<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@users=<F>;
flock(F,$LOCK_UN);
close (F);
$count=0 if (!$count);
$total=scalar(@users);
if ($count<$total)
{
	($username,$url)=split("\t",$users[$count]);
	use LWP::UserAgent;
	$ua = new LWP::UserAgent;
	$ua->agent("AgentName/0.1 " . $ua->agent);
	alarm(20) if ($sysid eq "Unix");
	my $req = new HTTP::Request GET => $url;
	my $res = $ua->request($req);
	alarm(0) if ($sysid eq "Unix");
	if ($res->is_success)
	{
		$html=$res->content;
		&parse;
	}
	else
	{
		open(F,">>$adcpath/temp/res");
		flock(F,$LOCK_EX);
		print F "$username:Dead link\n";
		flock(F,$LOCK_UN);
		close(F);
	}
	$count++;
	open (F,">$adcpath/temp/count");
	flock(F,$LOCK_EX);
	print F $count;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"<$adcpath/template/robot.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
}
else
{
	open (F,"<$basepath/adcenter.bup");
	flock(F,$LOCK_EX);
	@users=<F>;
	flock(F,$LOCK_UN);
	close (F);
	foreach(@users)
	{
		($em,$us)=split("\t",$_);
		$ems{$us}=$em;
	}
	open (F,"<$adcpath/temp/res");
	flock(F,$LOCK_EX);
	@words=<F>;
	flock(F,$LOCK_UN);
	close (F);
	foreach(@words)
	{
		chop;
		($username,$reason)=split(":",$_);
		push(@result,"<form action=\"$cgi/adcadmin.pl\" method=\"post\"><input type=\"hidden\" name=\"name\" value=\"$data{name}\"><input type=\"hidden\" name=\"password\" value=\"$data{password}\"><input type=\"hidden\" name=\"username\" value=\"$username\"><li><b>Username:</b> <a href=\"$cgi/adcgnfo.pl?name=$username&method=userinfo\" target=\"_blank\">$username</a> <a href=\"mailto:$ems{$username}\">$ems{$username}</a></li><br>Problem: $reason<br><center><input type=\"submit\" name=\"method\" value=\"remove\"><input type=\"submit\" name=\"method\" value=\"disable\"></center></form>\n");
	}
	push(@result,"<li>Nothing found</li\n") if (scalar(@result)==0);
	unlink ("$adcpath/temp/count");
	unlink ("$adcpath/temp/res");
	open (F,"<$adcpath/template/robres.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
}
sub error
{
	@error=@_;
	open (F,"<$adcpath/template/errors.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
}
sub parse
{
unless ($html=~/\<\!--begin $owntitle code--\>/i)
{
open (F,">>$adcpath/temp/res");
flock(F,$LOCK_EX);
print F "$username:No code\n";
flock(F,$LOCK_UN);
close (F);
}
}
sub errors
{
open(F,">>$adcpath/temp/res");
flock(F,$LOCK_EX);
print F "$username:Dead link\n";
flock(F,$LOCK_UN);
close(F);
$count++;
open (F,">$adcpath/temp/count");
flock(F,$LOCK_EX);
print F $count;
flock(F,$LOCK_UN);
close (F);
open (F,"<$adcpath/template/robot.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;   	
}

sub errauth
{
open (F,"<$adcpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub printres
{
	close(S);
	open(F,">>$adcpath/temp/res");
	flock(F,$LOCK_EX);
	print F "$username:Server in down\n";
	flock(F,$LOCK_UN);
	close(F);
	$count++;
	open (F,">$adcpath/temp/count");
	flock(F,$LOCK_EX);
	print F $count;
	flock(F,$LOCK_UN);
	close (F);
	open (F,"<$adcpath/template/robot.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
}