#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

open (F,"<$basepath/adcenter.srh");
flock(F,$LOCK_EX);
@sites=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@sites)
{
	chop;
	($unme,$usurl,$uscat,$ustit,$usdesc,$uskeyw)=split("\t",$_);
	open (F,"<$basepath/$unme/counter");
	flock(F,$LOCK_EX);
	$hits=<F>;
	flock(F,$LOCK_UN);
	close(F);
	push(@basic,"$hits\t$ustit\t$usurl\t$usdesc");
}
@basic=sort({$b<=>$a}@basic);
$i=0;
if (@basic>0)
{
foreach(@basic)
{
	($ushits,$ustit,$usurl,$usdesc)=split("\t",$_);
	$result.=qq~
<tr><font face="Verdana,Arial,Helvetica">
<td><a href="$usurl" target="_blank"><font size="2"><b>$ustit ($ushits hits)</b></font></a></td></font></tr>
<tr><font face="Verdana,Arial,Helvetica">
<td><font size="1">$usdesc</font></td></font></tr>
~;
	$i++;
	last if ($i==10);
}
}
else
{
	$result.=qq~
<tr><font face="Verdana,Arial,Helvetica">
<td><p align="center"><font size="2"><b>No sites in the exchange</b></font></td></font></tr>
~;
}
open (F,"<$adcpath/template/top.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
