#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

binmode STDIN;
read (STDIN,$buf,$ENV{CONTENT_LENGTH});
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$pdate="$month $date $year";

($boundary)=$ENV{CONTENT_TYPE}=~/boundary="([^"]+)"/; #";
($boundary)=$ENV{CONTENT_TYPE}=~/boundary=(\S+)/ unless $boundary;
$boundary="--".$boundary;
@file=split("\r\n$boundary",$buf);
foreach (@file)
{
	s/\r\n\r\n/delimeter/;
}
($field,$name)=split("delimeter",$file[0]);
($field,$file)=split("delimeter",$file[1]);
$bws=int($banwidth/256);
$bwf=$banwidth-int($banwidth/256)*256;
$bhs=int($banheight/256);
$bhf=$banheight-int($banheight/256)*256;
$word=chr(0x47).chr(0x49).chr(0x46).chr(0x38).chr(0x39).chr(0x61).chr($bwf).chr($bws).chr($bhf).chr($bhs);
$nextword=chr(0x47).chr(0x49).chr(0x46).chr(0x38).chr(0x37).chr(0x61).chr($bwf).chr($bws).chr($bhf).chr($bhs);
if (($file=~/^$word/ || $file=~/^$nextword/) && length($file)<=$mfilesize)
{
	open (F,">$adcpath/queye/$name.gif");
	flock(F,$LOCK_EX);
	binmode F;
	print F $file;
	flock(F,$LOCK_UN);
	close (F);
	open (FL, "<$adcpath/template/sucupl.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
push (@errors, "Your banner must be a GIF with size $banwidth x $banheight and not more than $mfilesize bytes");
open (FL, "<$adcpath/template/errupl.tpl");
@htmlpage=<FL>;
close (FL);
$htmlpage=join("\n",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
